' ChetOS 2000 (Version 1.18)
' This is the only ChetOS.
' This program was designed and programmed by Chet Zema
' More info on ChetOS in the readme file.
' Started: July 14, 1998. 4:20 p.m.
' Last updated: July 8, 2000. 10:50 p.m.
' $DYNAMIC
DEFINT A-Z
DECLARE SUB aFMenu ()                           ' File Menu
DECLARE SUB aOMenu ()                           ' Option Menu
DECLARE SUB aCMenu ()                           ' Command Menu (obsolete)
DECLARE SUB aMMenu ()                           ' Icon Menu
DECLARE SUB aHMenu ()                           ' Help Menu
DECLARE SUB timedate (t%)                       ' Time/Date Update and Screen Saver Control
DECLARE SUB ZActive (status$)                   ' Shows active object
DECLARE SUB rescreen (what$, full%)             ' Refreshs screen
DECLARE SUB ShutDown ()                         ' Nice shutdown screen
DECLARE SUB QbasicPaintIsGay (left%, Right%, YLeft%, bot%, clr%)        ' Clears a box of screen
DECLARE SUB hehe (left%, Right%, YLeft%, bot%, clr%)
DECLARE SUB InitMouse ()                        ' Puts MouseCode in an array
DECLARE SUB MouseStatus (lb%, rb%, MouseX%, MouseY%)      ' Gets Mouse Location
DECLARE SUB MouseDriver (ax%, bx%, cx%, dx%)    ' Talks to Mouse
DECLARE SUB mouseBuff ()                        ' Waits for mouse button's release
DECLARE FUNCTION mouseInit% ()                  ' Sets initial mouse values
DECLARE SUB mouseShow ()                        ' Shows the mouse cursor
DECLARE SUB MouseHide ()                        ' Hides the mouse cursor
DECLARE SUB MouseRange (X1%, Y1%, X2%, Y2%)     ' Sets range of mouse movement
DECLARE SUB mousePut (MouseX%, MouseY%)                   ' Puts the mouse at a certian location
DECLARE SUB StartMouse ()                       ' Detects mouse and starts it
DECLARE SUB InitScreen ()                       ' Sets default screen values
DECLARE SUB Welcome ()                          ' Welcome screen (obsolete)
DECLARE SUB InitProg ()                         ' Sets default values and gets configuration
DECLARE FUNCTION clkd% (left%, Right%, YLeft%, bot%, button$, in%)      ' Detects mouse click
DECLARE SUB ShowCoord ()                        ' Shows mouse coordantes (obsolete)
DECLARE SUB dbox (left%, Right%, YLeft%, bot%, clr%, fill%, fillclr%, dbl%)     ' Draws a box for Windows
DECLARE FUNCTION ButtonOk% (XLoc%, YLoc%, center%)     ' Shows a standard "OK" button
DECLARE FUNCTION ButtonCancel% (XLoc%, YLoc%, center%) ' Shows a standard "CANCEL" button
DECLARE SUB Win (left%, Right%, Top%, bot%, clr%, Title$)       ' Makes a Window box
DECLARE SUB Exec (Filename$)                    ' ChetScript Engine
DECLARE SUB DispErr (errmsg$, redraw)           ' Shows errors in a window
DECLARE SUB CPanel ()                           ' Control Panel (TestBed for ChetScript)
DECLARE SUB MakeBack (clr%, clr2%, hidemouse)   ' Draws a 2 color background
DECLARE SUB JFont (a$, c%, XCoordinate%, YCoordinate%, size!)   ' Fonts
DECLARE SUB RunSys ()                           ' Shows startup info and directs system startup
DECLARE FUNCTION proLine$ (fil%)                ' Finds a line in a file and sets variable
DECLARE SUB CLocate (XLoc%, YLoc%, text$, mhide%, var$, var%)   ' Centerable Locate
DECLARE SUB CWin (Offs%, Top%, bot%, clr%, Title$)      ' Centerable Window
DECLARE FUNCTION checkMMove ()                  ' Checks for Mouse Movement (Needed for ScreenSaver)
DECLARE SUB HitKey (co$)                        ' Detects a key hit
DECLARE FUNCTION hConvert% (c%, p%, ch$)        ' Converts CHAR to Pixel
DECLARE FUNCTION vConvert% (c%, p%, ch$)        ' Converts CHAR to Pixel
DECLARE SUB Drawicon (IconX%, IconY%, text$, refid%, itype%)    ' Draws a icon
DECLARE SUB GetIcon ()                          ' Gets icon image
DECLARE SUB Clicked ()                          ' Used in Main Moduale to detect mouse click
DECLARE SUB GetDesktop ()                       ' Gets Desktop Configuration
DECLARE SUB Delay (duration%)                   ' Slows the program down some
DECLARE SUB Reboot ()                           ' Reboots computer (DOS Mode only)
DECLARE SUB IconCreate ()                       ' Creates new Icons
DECLARE SUB IconDelete ()                       ' Deletes Icons
DECLARE SUB IconRename ()                       ' Rename Icons
DECLARE SUB SystemTest (item%)                  ' Shows system startup process
DECLARE SUB LoadGroup (ifile$)                  ' Loads a group configuration
DECLARE SUB GroupOS ()                          ' Runs the group
DECLARE SUB FirstRun (check%)                   ' Sets ChetOS Directory
DECLARE FUNCTION testStart ()                   ' Used to see if ChetOS is "running"
DECLARE SUB GetBasics (what%)                   ' Gets Basic Images (OK, CANCEL, DESKTOP)
DECLARE SUB DispStats ()                        ' Shows ChetOS Stats
DECLARE SUB InitStats ()                        ' Gets starting ChetOS Stats
DECLARE SUB HandleError (ernum)                 ' Handles Errors
DECLARE SUB ScreenSaver ()                      ' Runs a screen saver (Programmable)
DECLARE SUB KeyMouse (kMouse$)                  ' Move mouse with KeyBoard (NumPad)
DECLARE SUB InternalGame (game)                 ' Small Games
DECLARE SUB ControlPanel (panel)
DEFINT A-Z                                      ' Everything is a INTEGER

' ChetOS Main Variables
COMMON SHARED ver!, mode$, created$             ' ChetOS Stats
COMMON SHARED redra                             ' Program Starting Variable
COMMON SHARED fastload%, FirstRunReturn, restart' ChetOS Starting
COMMON SHARED inittime$, initdate$, runnum      ' Initial Stats

' GUI Settings
COMMON SHARED cancelthere, okthere              ' Ok and Cancel Variables
COMMON SHARED clr%, clr2%, gotdesktop%          ' Desktop Variables
COMMON SHARED yy4%, ottime%, ttime$, t%         ' Time/Date Variables
COMMON SHARED comx%, in$                   ' Ok and Cancel Stuff

' Mouse Variables
COMMON SHARED mouseok!, mouseok, mouseok#       ' Mouse Stuff
COMMON SHARED MouseX%, MouseY%, lb%, rb%, dx%, dy%        ' Mouse Variables
COMMON SHARED MouseXOld%, MouseYOld%, lbo%, rbo%              ' Mouse Variables (Screen Saver)
COMMON SHARED tempx%, tempy%                    ' KeyBoard Mouse
COMMON SHARED MRLeft%, MRRight%, MRTop%, MRBot% ' Mouse Range Variables

' Added to customize desktop
COMMON SHARED deskclr1%, deskclr2%, maxicon%, maxgicon% ' Icon Placement

' Screen Saver
COMMON SHARED ActiveSaver, ScrClr, NTimer, SaverDelay   ' Screen Saver
COMMON SHARED SaverEnabled

' Misc Stuff

CLEAR , , 5000                                  ' Set Stack
    PRINT "String Space", FRE("")
    PRINT "Unused Stack Space", FRE(-2)
    PRINT "Array Space", FRE(-1)
TYPE icons                                      ' Icon TYPE
        IconX AS INTEGER                                ' Location X
        IconY AS INTEGER                                ' Location Y
        iname AS STRING * 8                             ' Name of Icon
        ifile AS STRING * 8                             ' Filename of Icon
        refid AS INTEGER                                ' ???
        hotkey AS STRING * 1                            ' Hotkey
END TYPE
TYPE gicons                                     ' Group Icon Type
        refid AS INTEGER                                ' Same as Desktop ICON
        IconX AS INTEGER
        IconY AS INTEGER
        iname AS STRING * 8
        ifile AS STRING * 8
        hotkey AS STRING * 1
END TYPE

' Dimension Variables
DIM SHARED mouse$                               ' Mouse ASM Code
DIM SHARED iconimg(386)                         ' Picture of Regular Icon
DIM SHARED diconimg(386)                        ' Picture of Clicked Icon
DIM SHARED DeskTop(250)                         ' Quicker DESKTOP
DIM SHARED okimg(250)                           ' Quicker OK
DIM SHARED cancelimg(310)                       ' Quicker CANCEL
DIM SHARED charset(128, 8, 6)                   ' Font data
DIM SHARED icon(0 TO 20) AS icons               ' Desktop Icon Information
DIM SHARED gicon(0 TO 8) AS gicons              ' Group Icon Information
DIM SHARED back&(0 TO 9500)                     ' Temporary storage for Screen_Test

' Stupid things that can't go into Sub Modules
' End of stupid things that can't go into Sub Modules

RANDOMIZE TIMER                                 ' Randomize

ON ERROR GOTO handleit                          ' Error Handling
restart:
restart = 0
' Initialize program
        ' Check to see if this is the first time ChetOS was run.
        FirstRun (1): IF FirstRunReturn = 1 THEN FirstRun (2): FirstRunReturn = 0: GOTO restart
' -------------------

InitProg                                        ' Sets Initial Values and Tests System
InitScreen                                      ' Initializes Screen

remenu:

IF redra = 0 THEN rescreen "Desktop", 1         ' Don't ReDraw Desktop if FMAN Ran

DeskTop:

mousePut 320, 200                               ' Sets Starting Mouse Location

mouseShow                                       ' Shows the Mouse

' These lines run the entire OS, I have optimised it to use as little lines as
' possible when idle. This makes it respond to commands really quick.
'
' Begin Main OS
DO
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)    ' Gets Mouse Location
co$ = INKEY$: IF co$ <> "" THEN HitKey (co$)    ' KeyBoard Control
IF lb% = -1 THEN Clicked: GOTO clrscr           ' Left Mouse Button
IF rb% = -1 THEN reload = 1: rescreen "Desktop", 0 ' Right Mouse Button
timedate (t%)                                   ' Updates and refreshes time (screen saver)
IF restart = 1 THEN MouseHide: GOTO restart     ' Allows program restart
clrscr:
LOOP
' End Main OS

' Error Handling
handleit:
HandleError ERR
RESUME NEXT
' --------------

' Mouse HEX Assemble Code
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

' JezzBall
jezzdata:
        ' Ball Data
        DATA 00,00,00,04,04,04,04,00,00,00
        DATA 00,00,04,04,04,04,04,04,00,00
        DATA 00,04,04,04,04,04,04,04,04,00
        DATA 04,04,04,04,15,15,04,04,04,04
        DATA 04,04,04,15,15,15,15,04,04,04
        DATA 04,04,04,15,15,15,15,04,04,04
        DATA 04,04,04,04,15,15,04,04,04,04
        DATA 00,04,04,04,04,04,04,04,04,00
        DATA 00,00,04,04,04,04,04,04,00,00
        DATA 00,00,00,04,04,04,04,00,00,00
        ' Vertical Arrow
        DATA 00,00,15,00,00
        DATA 00,15,15,15,00
        DATA 15,15,15,15,15
        DATA 00,00,15,00,00
        DATA 00,00,15,00,00
        DATA 00,00,15,00,00
        DATA 00,00,15,00,00
        DATA 00,00,15,00,00
        DATA 00,00,15,00,00
        DATA 15,15,15,15,15
        DATA 00,15,15,15,00
        DATA 00,00,15,00,00
        ' HORIZONTAL ARROW DATA
        DATA 00,00,15,00,00,00,00,00,00,00,00,00,15,00,00
        DATA 00,15,15,00,00,00,00,00,00,00,00,00,15,15,00
        DATA 15,15,15,15,15,15,15,15,15,15,15,15,15,15,15
        DATA 00,15,15,00,00,00,00,00,00,00,00,00,15,15,00
        DATA 00,00,15,00,00,00,00,00,00,00,00,00,15,00,00
DEFSNG A-Z

REM $STATIC
DEFINT A-Z
SUB aFMenu
' The file menu
lb% = 0
MouseHide
CALL dbox(3, 62, 26, 130, 7, 1, 0, 0)
LINE (3, 107)-(62, 107)
COLOR 12
LOCATE 3, 2: PRINT "N"
LOCATE 4, 2: PRINT "O"
LOCATE 5, 2: PRINT "R"
LOCATE 6, 2: PRINT "D"
LOCATE 8, 3: PRINT "x"
COLOR 7
LOCATE 3, 3: PRINT "ew"
LOCATE 4, 3: PRINT "pen"
LOCATE 5, 3: PRINT "ename"
LOCATE 6, 3: PRINT "elete"
LOCATE 8, 2: PRINT "E": LOCATE 8, 4: PRINT "it"
mouseShow
mouseBuff
ZActive "Change Desktop"
DO
fco$ = INKEY$
IF fco$ = "n" THEN GOTO new
IF fco$ = "o" THEN GOTO openiet
IF fco$ = "r" THEN GOTO rename
IF fco$ = "d" THEN GOTO delete
IF fco$ = "x" THEN GOTO exiter
IF fco$ = "" THEN GOTO filedone
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
KeyMouse (fco$)
IF clkd(4, 61, 26, 48, "l", 1) = 1 THEN rescreen "Create New", 0: GOTO new
IF clkd(4, 61, 49, 65, "l", 1) = 1 THEN GOTO openiet
IF clkd(4, 61, 66, 80, "l", 1) = 1 THEN GOTO rename
IF clkd(4, 61, 81, 98, "l", 1) = 1 THEN GOTO delete
IF clkd(4, 61, 108, 129, "l", 1) = 1 THEN GOTO exiter
' Other Menu's Clicked
IF clkd(61, 130, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aOMenu: GOTO filedonen
IF clkd(180, 230, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aMMenu: GOTO filedonen
IF clkd(575, 639, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aHMenu: GOTO filedonen
' Time Clicked
IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
        mouseBuff
        IF t% = 0 THEN t% = 1: yy4% = 0: GOTO enddiff
        IF t% = 1 THEN t% = 0: yy4% = 0: GOTO enddiff
END IF
'IF wasiconclicked = 1 THEN goicon
enddiff:
IF lb% = -1 THEN GOTO filedone
timedate (t%)
lb% = 0
LOOP
new:
IconCreate
GOTO filedone
openiet:                                                                                                                                                                                                                                                                                                  GOTO filedone
DO
IF ButtonCancel(182, 237, 0) = 1 THEN EXIT DO
LOOP
GOTO filedone
rename:
GOTO filedone
delete:
GOTO filedone
exiter:
rescreen "Exit ChetOS", 0
CALL CWin(150, 174, 270, 4, "ChetOS")
CALL CLocate(14, 26, "Are You Sure You Want To Exit", 1, "", 0)
DO
exityn$ = INKEY$
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
KeyMouse exityn$
IF ButtonOk(223, 237, 0) = 1 THEN ShutDown
IF ButtonCancel(345, 237, 0) = 1 THEN LET exityn$ = "C"
IF exityn$ = CHR$(13) THEN ShutDown
IF exityn$ = CHR$(27) OR exityn$ = "C" THEN
        cancelthere = 0
        okthere = 0
        GOTO filedone
END IF
IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
        mouseBuff
        IF t% = 0 THEN t% = 1: yy4% = 0: GOTO BottomOfExit
        IF t% = 1 THEN t% = 0: yy4% = 0: GOTO BottomOfExit
END IF
BottomOfExit:
timedate (t%)
LOOP
filedone:
rescreen "Desktop", 0
filedonen:
lb% = 0
END SUB

DEFSNG A-Z
SUB aHMenu
' The help menu and the About window.
MouseHide
lb% = 0
CALL dbox(561, 633, 27, 89, 7, 1, 0, 0)
COLOR 12
LOCATE 3, 72: PRINT "C"
LOCATE 4, 72: PRINT "I"
LOCATE 5, 72: PRINT "A"
COLOR 7
LOCATE 3, 73: PRINT "ontents"
LOCATE 4, 73: PRINT "ndex"
LOCATE 5, 73: PRINT "bout"
co$ = ""
mouseBuff
ZActive "Help Menu"
mouseShow
DO
co$ = INKEY$
IF UCASE$(co$) = "C" THEN GOTO contents
IF UCASE$(co$) = "I" THEN GOTO index
IF UCASE$(co$) = "A" THEN GOTO about
IF co$ = "" THEN GOTO helpdone
timedate (t%)
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
KeyMouse co$
IF MouseX% >= 561 AND MouseX% <= 633 AND MouseY% >= 26 AND MouseY% <= 46 AND lb% = -1 THEN GOTO contents
IF MouseX% >= 561 AND MouseX% <= 633 AND MouseY% >= 47 AND MouseY% <= 61 AND lb% = -1 THEN GOTO index
IF MouseX% >= 561 AND MouseX% <= 633 AND MouseY% >= 61 AND MouseY% <= 84 AND lb% = -1 THEN GOTO about
' Other Menus Clicked
IF clkd(0, 61, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aFMenu: GOTO helpdone
IF clkd(61, 130, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aOMenu: GOTO helpdone
IF clkd(180, 230, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aMMenu: GOTO helpdone
' Time Clicked
IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
        mouseBuff
        IF t% = 0 THEN t% = 1: yy4% = 0: GOTO enddifh
        IF t% = 1 THEN t% = 0: yy4% = 0: GOTO enddifh
END IF
'IF wasiconclicked = 1 THEN goicon
enddifh:

IF lb% = -1 THEN rescreen "Desktop", 0: GOTO helpdone
LOOP
contents:
ZActive "Contents"
index:
ZActive "Index"
about:
MouseHide
rescreen "About ChetOS", 0
rehelp:
CALL CWin(150, 94, 370, 7, "About ChetOS")
LOCATE 9, 30: PRINT "Chet Operating System."
LOCATE 10, 30: PRINT "      VER."; ver!
LOCATE 12, 30: PRINT " ChetOS Is Running in"
CALL CLocate(13, 999, "", 0, mode$, 0)
LOCATE 14, 30: PRINT "         mode."
LOCATE 16, 28: PRINT "SYSTEM RESOURCES FREE:"
LOCATE 18, 26: PRINT "Created: "; created$
sr = INT(RND(80) * 99 + 1): LET sr$ = STR$(sr): LET sr$ = sr$ + "%":
LOCATE 16, 50: PRINT sr$
mouseBuff
lb% = 0
rb% = 0

CALL dbox(195, 290, 300, 320, 7, 0, 0, 1)
CALL JFont("Statistics", 7, 205, 304, 1.4)

CALL dbox(345, 435, 300, 320, 7, 0, 0, 1)
CALL JFont("More Info", 7, 355, 304, 1.4)
mouseShow
DO
cont$ = INKEY$
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
KeyMouse cont$
IF ButtonOk(260, 340, 1) = 1 THEN rescreen "Desktop", 0: EXIT DO
timedate (t%)
IF cont$ = "s" THEN
        cancelthere = 0
        okthere = 0
        DispStats
        GOTO rehelp
END IF

IF cont$ = CHR$(13) THEN
        cancelthere = 0
        okthere = 0
        rescreen "Desktop", 0
        EXIT DO
END IF
IF clkd(195, 290, 300, 320, "l", 1) = 1 THEN
        okthere = 0
        DispStats
        GOTO rehelp
END IF
' Time Clicked
IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
        mouseBuff
        IF t% = 0 THEN t% = 1: yy4% = 0: GOTO enddifh
        IF t% = 1 THEN t% = 0: yy4% = 0: GOTO enddifh
END IF

LOOP
helpdone:
lb% = 0
END SUB

DEFINT A-Z
SUB aMMenu
' Allows keyboard user to access icons
Top:
lb% = 0
locy = 2
COLOR 7
MouseHide
ZActive "Menu"
height = 32 + ((maxicon - 1) * 16)
CALL dbox(183, 250, 26, height, 7, 1, 0, 0)
FOR x = 0 TO maxicon - 2
locy = locy + 1
locx = 24
        FOR temp = 1 TO LEN(icon(x).iname)
                nextletter$ = MID$(icon(x).iname, temp, 1)
                IF UCASE$(nextletter$) = UCASE$(icon(x).hotkey) THEN COLOR 12
                LOCATE locy, locx: PRINT nextletter$
                locx = locx + 1
                COLOR 7
        NEXT
NEXT
mouseBuff
mouseShow
cmaxicon = maxicon - 1
Right = 250
left = 183
DO
mcom$ = INKEY$
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
KeyMouse mcom$
IF lb = -1 OR mcom$ <> "" THEN
        
        IF cmaxicon = 1 THEN IF clkd%(30, 48, left%, Right%, "l", 1) = 1 THEN LoadGroup (icon(0).ifile): EXIT DO
        IF cmaxicon > 1 AND cmaxicon <= 2 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
        END IF
        IF cmaxicon > 2 AND cmaxicon <= 3 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
        END IF
        IF cmaxicon > 3 AND cmaxicon <= 4 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(183, 250, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
        END IF
        IF cmaxicon > 4 AND cmaxicon <= 5 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
       END IF
        IF cmaxicon > 5 AND cmaxicon <= 6 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
                IF clkd%(left%, Right%, 113, 128, "l", 1) = 1 OR mcom$ = icon(5).hotkey THEN LoadGroup (icon(5).ifile): EXIT DO
        END IF
        IF cmaxicon > 6 AND cmaxicon <= 7 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
                IF clkd%(left%, Right%, 113, 128, "l", 1) = 1 OR mcom$ = icon(5).hotkey THEN LoadGroup (icon(5).ifile): EXIT DO
                IF clkd%(left%, Right%, 129, 144, "l", 1) = 1 OR mcom$ = icon(6).hotkey THEN LoadGroup (icon(6).ifile): EXIT DO
        END IF
        IF cmaxicon > 6 AND cmaxicon <= 7 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
                IF clkd%(left%, Right%, 113, 128, "l", 1) = 1 OR mcom$ = icon(5).hotkey THEN LoadGroup (icon(5).ifile): EXIT DO
                IF clkd%(left%, Right%, 129, 144, "l", 1) = 1 OR mcom$ = icon(6).hotkey THEN LoadGroup (icon(6).ifile): EXIT DO
        END IF
        IF cmaxicon > 7 AND cmaxicon <= 8 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
                IF clkd%(left%, Right%, 113, 128, "l", 1) = 1 OR mcom$ = icon(5).hotkey THEN LoadGroup (icon(5).ifile): EXIT DO
                IF clkd%(left%, Right%, 129, 144, "l", 1) = 1 OR mcom$ = icon(6).hotkey THEN LoadGroup (icon(6).ifile): EXIT DO
                IF clkd%(left%, Right%, 145, 160, "l", 1) = 1 OR mcom$ = icon(7).hotkey THEN LoadGroup (icon(7).ifile): EXIT DO
        END IF
        IF cmaxicon > 8 AND cmaxicon <= 9 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
                IF clkd%(left%, Right%, 113, 128, "l", 1) = 1 OR mcom$ = icon(5).hotkey THEN LoadGroup (icon(5).ifile): EXIT DO
                IF clkd%(left%, Right%, 129, 144, "l", 1) = 1 OR mcom$ = icon(6).hotkey THEN LoadGroup (icon(6).ifile): EXIT DO
                IF clkd%(left%, Right%, 145, 160, "l", 1) = 1 OR mcom$ = icon(7).hotkey THEN LoadGroup (icon(7).ifile): EXIT DO
                IF clkd%(left%, Right%, 161, 176, "l", 1) = 1 OR mcom$ = icon(8).hotkey THEN LoadGroup (icon(8).ifile): EXIT DO
        END IF
        IF cmaxicon > 9 AND cmaxicon <= 10 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
                IF clkd%(left%, Right%, 113, 128, "l", 1) = 1 OR mcom$ = icon(5).hotkey THEN LoadGroup (icon(5).ifile): EXIT DO
                IF clkd%(left%, Right%, 129, 144, "l", 1) = 1 OR mcom$ = icon(6).hotkey THEN LoadGroup (icon(6).ifile): EXIT DO
                IF clkd%(left%, Right%, 145, 160, "l", 1) = 1 OR mcom$ = icon(7).hotkey THEN LoadGroup (icon(7).ifile): EXIT DO
                IF clkd%(left%, Right%, 161, 176, "l", 1) = 1 OR mcom$ = icon(8).hotkey THEN LoadGroup (icon(8).ifile): EXIT DO
                IF clkd%(left%, Right%, 177, 192, "l", 1) = 1 OR mcom$ = icon(9).hotkey THEN LoadGroup (icon(9).ifile): EXIT DO
        END IF
        IF cmaxicon > 10 AND cmaxicon <= 11 THEN
                IF clkd%(left%, Right%, 30, 48, "l", 1) = 1 OR mcom$ = icon(0).hotkey THEN LoadGroup (icon(0).ifile): EXIT DO
                IF clkd%(left%, Right%, 49, 64, "l", 1) = 1 OR mcom$ = icon(1).hotkey THEN LoadGroup (icon(1).ifile): EXIT DO
                IF clkd%(left%, Right%, 65, 80, "l", 1) = 1 OR mcom$ = icon(2).hotkey THEN LoadGroup (icon(2).ifile): EXIT DO
                IF clkd%(left%, Right%, 81, 96, "l", 1) = 1 OR mcom$ = icon(3).hotkey THEN LoadGroup (icon(3).ifile): EXIT DO
                IF clkd%(left%, Right%, 97, 112, "l", 1) = 1 OR mcom$ = icon(4).hotkey THEN LoadGroup (icon(4).ifile): EXIT DO
                IF clkd%(left%, Right%, 113, 128, "l", 1) = 1 OR mcom$ = icon(5).hotkey THEN LoadGroup (icon(5).ifile): EXIT DO
                IF clkd%(left%, Right%, 129, 144, "l", 1) = 1 OR mcom$ = icon(6).hotkey THEN LoadGroup (icon(6).ifile): EXIT DO
                IF clkd%(left%, Right%, 145, 160, "l", 1) = 1 OR mcom$ = icon(7).hotkey THEN LoadGroup (icon(7).ifile): EXIT DO
                IF clkd%(left%, Right%, 161, 176, "l", 1) = 1 OR mcom$ = icon(8).hotkey THEN LoadGroup (icon(8).ifile): EXIT DO
                IF clkd%(left%, Right%, 177, 192, "l", 1) = 1 OR mcom$ = icon(9).hotkey THEN LoadGroup (icon(9).ifile): EXIT DO
                IF clkd%(left%, Right%, 193, 208, "l", 1) = 1 OR mcom$ = icon(10).hotkey THEN LoadGroup (icon(10).ifile): EXIT DO
        END IF
       
        ' Other Menu's Clicked
        IF clkd(0, 61, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aFMenu: GOTO donemenub
        IF clkd(61, 130, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aOMenu: GOTO donemenub
        IF clkd(575, 639, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aHMenu: GOTO donemenub
        IF mcom$ = "" THEN GOTO donemenu
        ' Time Clicked
        IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
                mouseBuff
                IF t% = 0 THEN t% = 1: yy4% = 0: GOTO enddifm
                IF t% = 1 THEN t% = 0: yy4% = 0: GOTO enddifm
        END IF
enddifm:
        IF lb% = -1 THEN GOTO donemenu
        lb% = 0
END IF
reloop:
timedate (t%)
LOOP
donemenu:
rescreen "Desktop", 0
donemenub:
lb% = 0
END SUB

DEFSNG A-Z
SUB aOMenu
' Options menu
lb% = 0
MouseHide
CALL dbox(63, 190, 26, 115, 7, 1, 0, 0)
COLOR 12
LOCATE 3, 10: PRINT "u"
LOCATE 4, 9: PRINT "R"
LOCATE 5, 9: PRINT "C"
LOCATE 6, 12: PRINT "t"
LOCATE 7, 11: PRINT "b"
COLOR 7
LOCATE 3, 9: PRINT "R": LOCATE 3, 11: PRINT "n File"
LOCATE 4, 10: PRINT "edraw Screen"
LOCATE 5, 10: PRINT "ontrol Panel"
LOCATE 6, 9: PRINT "Res": LOCATE 6, 13: PRINT "art Program"
LOCATE 7, 9: PRINT "Re": LOCATE 7, 12: PRINT "oot Computer"
mouseShow
mouseBuff
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
ZActive "System Options"
DO
o$ = INKEY$
IF o$ = "u" THEN GOTO fman
IF o$ = "r" THEN reload% = 1: rescreen "Desktop", 1: GOTO doneopt
IF o$ = "c" THEN CPanel: GOTO doneopt
IF o$ = "t" THEN restart% = 1: GOTO doneoptb
IF o$ = "b" THEN rescreen "Reboot ???", 0: Reboot: GOTO doneopt
IF o$ = "" THEN rescreen "Command-Line", 0: GOTO doneopt
lb% = 0
rb% = 0
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
KeyMouse o$
IF clkd(64, 168, 31, 47, "l", 1) = 1 THEN GOTO fman: GOTO doneopt
IF clkd(64, 168, 48, 63, "l", 1) = 1 THEN reload% = 1: rescreen "Desktop", 1: GOTO doneoptb
IF clkd(64, 168, 64, 80, "l", 1) = 1 THEN CPanel: GOTO doneopt
IF clkd(64, 168, 81, 100, "l", 1) = 1 THEN restart% = 1: GOTO doneoptb
IF clkd(64, 168, 101, 114, "l", 1) = 1 THEN rescreen "Reboot ???", 0: Reboot: GOTO doneopt
' Other Menus Clicked
IF clkd(0, 61, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aFMenu: GOTO doneoptb
IF clkd(180, 230, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aMMenu: GOTO doneoptb
IF clkd(575, 639, 0, 25, "l", 1) = 1 THEN rescreen "", 0: aHMenu: GOTO doneoptb
' Time Clicked
IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
        mouseBuff
        IF t% = 0 THEN t% = 1: yy4% = 0: GOTO enddifo
        IF t% = 1 THEN t% = 0: yy4% = 0: GOTO enddifo
END IF
'IF wasiconclicked = 1 THEN goicon
enddifo:
IF lb% = -1 THEN GOTO doneopt
lb% = 0
timedate (t%)
lb% = 0
LOOP
fman:
MouseHide
rescreen "Run File", 0
dbox 60, 580, 90, 370, 15, 1, 0, 0
CLocate 15, 999, "Please Wait", 0, "", 0
CHAIN "fopen2.bas"
lb% = 0
CPanel:
doneopt:
lb% = 0
rescreen "Desktop", 0
doneoptb:
END SUB

DEFINT A-Z
FUNCTION ButtonCancel (XLoc%, YLoc%, center%)
IF inp$ = "" THEN inp$ = INKEY$
IF cancelthere = 0 THEN
MouseHide
CALL hehe(XLoc%, XLoc% + 72, YLoc%, YLoc% + 22, 0)
LINE (XLoc%, YLoc%)-(XLoc% + 71, YLoc% + 18), 7, B
LINE (XLoc% + 2, YLoc% + 2)-(XLoc% + 73, YLoc% + 20), 7, B
PUT (XLoc% + 14, YLoc% + 6), cancelimg%
cancelthere = 1
mouseShow
END IF
IF inp$ = "" THEN inp$ = INKEY$
IF inp$ = "" THEN inp$ = INKEY$
IF clkd(XLoc%, XLoc% + 81, YLoc%, YLoc% + 22, "l", 1) = 1 OR INKEY$ = CHR$(27) THEN
        ButtonCancel = 1
        cancelthere = 0
        okthere = 0
END IF
END FUNCTION

FUNCTION ButtonOk (XLoc%, YLoc%, center%)
IF inp$ = "" THEN inp$ = INKEY$
IF okthere = 0 THEN
        IF center% = 1 THEN XLoc% = 299
MouseHide
        CALL hehe(XLoc%, XLoc% + 55, YLoc%, YLoc% + 22, 0)
        LINE (XLoc%, YLoc%)-(XLoc% + 40, YLoc% + 18), 7, B
        LINE (XLoc% + 2, YLoc% + 2)-(XLoc% + 42, YLoc% + 20), 7, B
        PUT (XLoc% + 14, YLoc% + 6), okimg%
mouseShow
        okthere = 1
END IF
IF inp$ = "" THEN inp$ = INKEY$
IF center% = 1 THEN XLoc% = 317 - 28
IF inp$ = "" THEN inp$ = INKEY$
IF clkd(XLoc%, XLoc% + 53, YLoc%, YLoc% + 21, "l", 1) = 1 OR inp$ = CHR$(13) THEN
        ButtonOk = 1
        cancelthere = 0
        okthere = 0
        mouseBuff
END IF
END FUNCTION

FUNCTION checkMMove
IF MouseX% <> MouseXOld% OR MouseY% <> MouseYOld% THEN checkMMove = 1
END FUNCTION

SUB Clicked
IF clkd(0, 61, 0, 25, "l", 1) = 1 THEN aFMenu: gcl = 1
IF clkd(61, 130, 0, 25, "l", 1) = 1 THEN aOMenu: gcl = 1
IF clkd(180, 230, 0, 25, "l", 1) = 1 THEN aMMenu: gcl = 1
IF clkd(575, 639, 0, 25, "l", 1) = 1 THEN aHMenu: gcl = 1
IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
        mouseBuff
        IF t% = 0 THEN t% = 1: yy4% = 0: GOTO enddif
        IF t% = 1 THEN t% = 0: yy4% = 0: GOTO enddif
END IF
'IF wasiconclicked = 1 THEN goicon
enddif:
END SUB

FUNCTION clkd% (left, Right, Top, bot, button$, in%)
' Function will return TRUE if the params are met
' Left is the top area of the "box"; Right is the bottom area.
' YLeft is the left area; Bot is the right area.
' Button is the button clicked. (l=Left;r=Right)
' In is wether you want to know if the user click in or out of the area.
' In=1 if you want the area inside
'
IF in = 1 THEN
IF button$ = "l" THEN
        IF MouseX% >= left AND MouseX% <= Right AND MouseY% >= Top AND MouseY% <= bot AND lb% = -1 THEN clkd = 1
END IF
IF button$ = "r" THEN
        IF MouseX% >= left AND MouseX% <= Right AND MouseY% >= Top AND MouseY% <= bot AND rb% = -1 THEN clkd = 1
END IF
END IF
IF in = 0 THEN
IF button$ = "l" THEN
        IF MouseX% < left OR MouseX% > Right AND MouseY% < YLeft OR MouseY% > bot AND lb% = -1 THEN clkd% = 1
END IF
IF button$ = "r" THEN
        IF MouseX% < left OR MouseX% > Right AND MouseY% < YLeft OR MouseY% > bot AND rb% = -1 THEN clkd% = 1
END IF
END IF
END FUNCTION

DEFSNG A-Z
SUB CLocate (XLoc%, YLoc%, text$, mhide%, var$, var%)
' Centerable Locate Statement, Allows 1 integeral or 1 string value.
IF var$ <> "" THEN text$ = text$ + " " + var$
IF var% <> 0 THEN text$ = text$ + " " + STR$(var%)
IF YLoc% = 999 THEN YLoc% = 40 - INT(LEN(text$) / 2)
IF mhide% = 1 THEN MouseHide
LOCATE XLoc%, YLoc%: PRINT text$
IF mhide% = 1 THEN mouseShow
END SUB

DEFINT A-Z
SUB CMenu
' Command-Line Input
lb% = 0
'rescreen "Command-Line", 0
DispErr "A security level greater than 5 is needed to access the command line.", 1
MouseHide
CALL Win(38, 290, 46, 150, 7, "Command Line")
CALL dbox(54, 285, 94, 113, 7, 0, 0, 0)

LOCATE 7, 8: PRINT "C:\"
comx = 10
LOCATE 7, comx + 1: PRINT CHR$(219)
count = 0
mouseShow
DO
inp$ = INKEY$
IF inp$ = "" THEN GOTO hello
IF ASC(inp$) = 13 THEN
   IF in$ <> "" THEN LET ine$ = in$
   LOCATE 7, comx + 1: PRINT " ": EXIT DO
END IF
count = count + 1
IF count >= 13 THEN
        LOCATE 7, comx
        PRINT CHR$(219); " "
        BEEP
        'inp$ = ""
        'count = count - 1
        comx = comx - 1
        LET gotohello = 1
END IF
IF ASC(inp$) = 8 THEN
        IF comx = 10 THEN GOTO hello
        LOCATE 7, comx
        PRINT CHR$(219); " "
        inp$ = ""
        LET comx = comx - 1
        count = count - 1
        GOTO hello
IF gotohello = 1 THEN GOTO hello
END IF
IF ASC(inp$) <> 8 THEN LET in$ = in$ + inp$
IF ASC(inp$) <> 8 THEN LET comx = comx + 1
IF ASC(inp$) <> 8 THEN LOCATE 7, comx: PRINT inp$: LOCATE 7, comx + 1: PRINT CHR$(219)
hello:

timedate (t%)
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF ButtonOk(80, 120, 0) = 1 THEN EXIT DO
IF ButtonCancel(170, 120, 0) = 1 THEN EXIT DO
lb% = -1
LOOP
comml$ = in$
IF comml$ = "" THEN GOTO nogohere
IF comml$ = "z" THEN LET comml$ = "command.com"
LET pre$ = "C:\"
LET comml$ = pre$ + comml$
RESET
OPEN "chetos.dat" FOR OUTPUT AS #1
PRINT #1, comml$
PRINT #1, rdir$
RESET
SHELL comml$
'RUN "runextrn.bas"
nogohere:
lb% = 0
END SUB

' 1 = System Colors
' 2 = Time and Date
' 3 = Screen Savers
' 4 =
' 5 =
SUB ControlPanel (panel)

IF panel = 1 THEN               ' Control Colors

END IF

IF panel = 2 THEN               ' Control Time and Date
END IF

IF panel = 3 THEN               ' Control Screen Savers
END IF

END SUB

DEFSNG A-Z
SUB CPanel
lb% = -1
Exec "cpanel.cxe"
END SUB

SUB CWin (Offs%, Top%, bot%, clr%, Title$)
' Centered Window
left% = 317 - Offs%
Right% = 317 + Offs%
MouseHide
CALL dbox(left%, Right%, Top%, bot%, clr%, 1, 0, 1)
LINE (left%, Top% + 18)-(Right%, Top% + 18), clr%
CALL JFont(Title$, 15, left% + 4, Top% + 3, 2)
mouseShow
END SUB

DEFINT A-Z
SUB dbox (left%, Right%, YLeft%, bot%, clr%, fill%, fillclr%, dbl)
' Left is the top area of the "box"; Right is the bottom area.
' YLeft is the left area; Bot is the right area.
' Clr% is the outer color; Fill equals 1 if you want it to be filled.
' Fillclr is the fill color, set it to anything if you have fill=0
xt = left
xb = Right
yl = YLeft
yr = bot
IF dbl = 0 THEN
IF fill% = 0 THEN
        LINE (xt, yl)-(xb, yr), clr, B
END IF
IF fill% = 1 THEN
        CALL hehe(left%, Right, YLeft%, bot%, fillclr%)
        LINE (xt, yl)-(xb, yr), clr, B
END IF
END IF
IF dbl = 1 THEN
IF fill% = 0 THEN
        LINE (xt, yl)-(xb, yr), clr, B
        LINE (xt + 1, yl + 1)-(xb - 1, yr - 1), clr, B
END IF
IF fill% = 1 THEN
        CALL hehe(left%, Right, YLeft%, bot%, fillclr%)
        LINE (xt, yl)-(xb, yr), clr, B
        LINE (xt + 1, yl + 1)-(xb + 1, yr + 1), clr, B
END IF
END IF
END SUB

DEFSNG A-Z
SUB Delay (duration%)
' Delays the program for a certian amout of time, I am not sure the actual
' length, it is all relative.
IF fastload% = 1 THEN GOTO byedelay
FOR count% = 1 TO duration%
IF INKEY$ = "A" THEN fastload% = 1: SOUND 100, 2: GOTO byedelay
SOUND 0, 1
NEXT count%
byedelay:
END SUB

DEFINT A-Z
SUB DispErr (errmsg$, redraw)
rescreen "Error", 0

IF LEN(errmsg$) > 1 AND LEN(errmsg$) <= 50 THEN
        IF LEN(errmsg$) <= 8 THEN
                MouseHide
                CALL Win(214, 430, 142, 240, 7, "Error")
                CALL CLocate(12, 999, errmsg$, 0, "", 0)
                mouseShow
                DO
                IF ButtonOk(293, 205, 0) = 1 THEN
                        IF redraw = 1 THEN rescreen "Desktop", 0
                        EXIT DO
                END IF
                timedate (t%)
                LOOP
        END IF

        IF LEN(errmsg$) > 9 AND LEN(errmsg$) <= 35 THEN
                MouseHide
                CALL Win(170, 460, 142, 240, 7, "Error")
                CALL CLocate(12, 999, errmsg$, 0, "", 0)
                mouseShow
                DO
                IF ButtonOk(293, 205, 0) = 1 THEN
                        IF redraw = 1 THEN rescreen "Desktop", 0
                        EXIT DO
                END IF
                timedate (t%)
                LOOP
        END IF
        IF LEN(errmsg$) > 35 THEN
                MouseHide
                CALL Win(110, 520, 142, 240, 7, "Error")
                CALL CLocate(12, 999, errmsg$, 0, "", 0)
                mouseShow
                DO
                IF ButtonOk(293, 205, 0) = 1 THEN
                        IF redraw = 1 THEN rescreen "Desktop", 0
                        EXIT DO
                END IF
                timedate (t%)
                LOOP
        END IF
END IF
IF LEN(errmsg$) > 50 AND LEN(errmsg$) <= 100 THEN
cnt = 40
DO
cnt = cnt + 1
errmsg1$ = LEFT$(errmsg$, cnt)
IF RIGHT$(errmsg1$, 1) = CHR$(32) THEN cnt2 = cnt: EXIT DO
LOOP
errmsg2$ = RIGHT$(errmsg$, (LEN(errmsg$) - cnt2))
       MouseHide
       CALL Win(110, 520, 142, 255, 7, "Error")
       CALL CLocate(12, 999, errmsg1$, 0, "", 0)
       CALL CLocate(13, 999, errmsg2$, 0, "", 0)
       mouseShow
       DO
        inp$ = INKEY$
        CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
        KeyMouse inp$
       IF ButtonOk(293, 220, 0) = 1 THEN
        IF redraw = 1 THEN rescreen "Desktop", 0
        EXIT DO
        END IF
       timedate (t%)
       LOOP
END IF

IF LEN(errmsg$) > 100 AND LEN(errmsg$) <= 150 THEN
cnt = 40
DO
cnt = cnt + 1
errmsg1$ = LEFT$(errmsg$, cnt)
IF RIGHT$(errmsg1$, 1) = CHR$(32) THEN cnt2 = cnt: EXIT DO
LOOP
errmsg2$ = RIGHT$(errmsg$, (LEN(errmsg$) - cnt2))
cnt = 40
DO
cnt = cnt + 1
errmsg3$ = LEFT$(errmsg2$, cnt)
IF RIGHT$(errmsg3$, 1) = CHR$(32) THEN cnt2 = cnt: EXIT DO
LOOP
errmsg4$ = RIGHT$(errmsg2$, (LEN(errmsg2$) - cnt2))
cnt = 40
DO
cnt = cnt + 1
errmsg5$ = LEFT$(errmsg4$, cnt)
IF RIGHT$(errmsg5$, 1) = CHR$(32) OR RIGHT$(errmsg5$, 1) = "" THEN cnt2 = cnt: EXIT DO
LOOP
errmsg6$ = RIGHT$(errmsg4$, (LEN(errmsg4$) - cnt2))
     
      MouseHide
       CALL Win(110, 520, 142, 285, 7, "Error")
       CALL CLocate(12, 999, errmsg1$, 0, "", 0)
       CALL CLocate(13, 999, errmsg3$, 0, "", 0)
       CALL CLocate(14, 999, errmsg5$, 0, "", 0)
       CALL CLocate(15, 999, errmsg6$, 0, "", 0)
      
       mouseShow
       DO
       IF ButtonOk(293, 255, 0) = 1 THEN
        IF redraw = 1 THEN rescreen "Desktop", 0
        EXIT DO
        END IF
       timedate (t%)
       LOOP
END IF

IF LEN(errmsg$) > 150 AND LEN(errmsg$) <= 220 THEN
cnt& = 40
DO
cnt& = cnt& + 1
errmsg1$ = LEFT$(errmsg$, cnt&)
IF RIGHT$(errmsg1$, 1) = CHR$(32) OR RIGHT$(errmsg1$, 1) = "." THEN cnt2& = cnt&: EXIT DO
LOOP
errmsg2$ = RIGHT$(errmsg$, (LEN(errmsg$) - cnt2&))
cnt& = 40
DO
cnt& = cnt& + 1
errmsg3$ = LEFT$(errmsg2$, cnt&)
IF RIGHT$(errmsg3$, 1) = CHR$(32) OR RIGHT$(errmsg3$, 1) = "." THEN cnt2& = cnt&: EXIT DO
LOOP
errmsg4$ = RIGHT$(errmsg2$, (LEN(errmsg2$) - cnt2&))
cnt& = 40
DO
cnt& = cnt& + 1
errmsg5$ = LEFT$(errmsg4$, cnt&)
IF RIGHT$(errmsg5$, 1) = CHR$(32) OR RIGHT$(errmsg5$, 1) = "." OR RIGHT$(errmsg5$, 1) = "" THEN cnt2& = cnt&: EXIT DO
LOOP
errmsg6$ = RIGHT$(errmsg4$, (LEN(errmsg4$) - cnt2&))
cnt& = 40
DO
cnt& = cnt& + 1
errmsg7$ = LEFT$(errmsg6$, cnt&)
IF RIGHT$(errmsg7$, 1) = CHR$(32) OR RIGHT$(errmsg7$, 1) = "" OR RIGHT$(errmsg7$, 1) = "." THEN cnt2& = cnt&: EXIT DO
LOOP
errmsg8$ = RIGHT$(errmsg6$, (LEN(errmsg6$) - cnt2&))

      MouseHide
       CALL Win(110, 520, 142, 305, 7, "Error")
       CALL CLocate(12, 999, errmsg1$, 0, "", 0)
       CALL CLocate(13, 999, errmsg3$, 0, "", 0)
       CALL CLocate(14, 999, errmsg5$, 0, "", 0)
       CALL CLocate(15, 999, errmsg7$, 0, "", 0)
       CALL CLocate(16, 999, errmsg8$, 0, "", 0)
       mouseShow
       DO
       IF ButtonOk(293, 275, 0) = 1 THEN
        IF redraw = 1 THEN rescreen "Desktop", 0
        EXIT DO
        END IF
       timedate (t%)
       LOOP
END IF


END SUB

DEFLNG A-Z
SUB DispStats
ZActive "Stats"
MouseHide
CWin 135, 60, 380, 7, "Stats"
LOCATE 6, 29: PRINT "Chet Operating System"
LOCATE 8, 33: PRINT "Version " + STR$(ver!)
LOCATE 10, 26: PRINT "Run Number:  " + STR$(runnum%)
LOCATE 11, 26: PRINT "Time Started: " + inittime$
LOCATE 12, 26: PRINT "Date Started: " + initdate$
LOCATE 13, 26: PRINT "ChetOS has been running for: "
LOCATE 15, 41: PRINT ": Years "
LOCATE 16, 41: PRINT ": Months"
LOCATE 17, 41: PRINT ": Days"
LOCATE 18, 41: PRINT ": Hours"
LOCATE 19, 41: PRINT ": Minutes"
LOCATE 20, 41: PRINT ": Seconds"
mouseShow
okthere% = 0
' First Caluate Dates
DO
date1$ = initdate$
date2$ = DATE$
date1$ = LTRIM$(RTRIM$(date1$))   ' Trim Dates
date2$ = LTRIM$(RTRIM$(date2$))
date1m = VAL(LEFT$(date1$, 2))    ' Extract Day, Months, and Years
date1d = VAL(MID$(date1$, 4, 2))
date1y = VAL(RIGHT$(date1$, 4))
date2m = VAL(LEFT$(date2$, 2))
date2d = VAL(MID$(date2$, 4, 2))
date2y = VAL(RIGHT$(date2$, 4))

time1$ = inittime$
time2$ = TIME$
time1$ = LTRIM$(RTRIM$(time1$))    'Trim Times
time2$ = LTRIM$(RTRIM$(time2$))
time1h = VAL(LEFT$(time1$, 2))     ' Extract Hours, Minutes, and Seconds
time1m = VAL(MID$(time1$, 4, 2))
time1s = VAL(RIGHT$(time1$, 2))
time2h = VAL(LEFT$(time2$, 2))
time2m = VAL(MID$(time2$, 4, 2))
time2s = VAL(RIGHT$(time2$, 2))

minute = (time2m - time1m)
second = (time2s - time1s)
IF time2s < time1s THEN second = second + 60
IF second = 59 THEN minute = minute + 1
IF minute = 59 THEN hour = hour + 1
IF hour = 24 THEN day = day + 1
IF day = 30 THEN month = month + 1
IF month = 12 THEN year = year + 1

IF oyear <> year THEN LOCATE 15, 37: PRINT year
IF omonth <> month THEN LOCATE 16, 37: PRINT month
IF oday <> day THEN LOCATE 17, 37: PRINT day
IF ohour <> hour THEN LOCATE 18, 37: PRINT hour
IF ominute <> minute THEN LOCATE 19, 37: PRINT minute
IF osecond <> second THEN LOCATE 20, 37: PRINT second
osecond = second
ominute = minute
ohour = hour
oday = day
omonth = month
oyear = year
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF ButtonOk(200, 350, 1) = 1 THEN rescreen "About ChetOS", 0: EXIT DO
IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
        mouseBuff
        IF t% = 0 THEN t% = 1: yy4% = 0: GOTO donetime
        IF t% = 1 THEN t% = 0: yy4% = 0: GOTO donetime
END IF
donetime:
timedate (t%)
LOOP
END SUB

DEFINT A-Z
SUB Drawicon (IconX, IconY, text$, refid, itype)
IF itype = 0 THEN PUT (IconX, IconY), iconimg%, PSET
IF itype = 1 THEN PUT (IconX, IconY), diconimg%, PSET
text$ = LTRIM$(RTRIM$(text$))
IF LEN(text$) = 1 THEN JFont text$, 15, IconX + 14, IconY + 35, 1
IF LEN(text$) = 2 THEN JFont text$, 15, IconX + 12, IconY + 35, 1
IF LEN(text$) = 3 THEN JFont text$, 15, IconX + 9, IconY + 35, 1
IF LEN(text$) = 4 THEN JFont text$, 15, IconX + 6, IconY + 35, 1
IF LEN(text$) = 5 THEN JFont text$, 15, IconX + 3, IconY + 35, 1
IF LEN(text$) = 6 THEN JFont text$, 15, IconX + 0, IconY + 35, 1
IF LEN(text$) = 7 THEN JFont text$, 15, IconX - 3, IconY + 35, 1
IF LEN(text$) = 8 THEN JFont text$, 15, IconX - 6, IconY + 35, 1
END SUB

SUB Exec (Filename$)
' This is an amazing feature that I have NEVER seen in a QBasic OS.
' It will allow users to make thier own 'Exectuable'
' Programs for ChetOS. Now, if someone wants a calculator or a
' word processor, they can write one and use ChetOS's GUI.
' I think the actual term is API, but it is not as indepth as an API.
OPEN Filename$ FOR INPUT AS #25
IF proLine$(25) <> "CXE" THEN DispErr "Error in ChetOS Executable.  First line must be CXE", 0: CLOSE : GOTO nocomp
DO
progline$ = proLine$(25)

IF progline$ = "mousehide" THEN
        MouseHide
END IF
IF progline$ = "locate" THEN
        XLoc% = VAL(proLine$(25))
        YLoc% = VAL(proLine$(25))
        text$ = proLine$(25)
LOCATE XLoc%, YLoc%: PRINT text$
END IF

IF progline$ = "win" THEN
        left% = VAL(proLine$(25))
        Right% = VAL(proLine$(25))
        Top% = VAL(proLine$(25))
        bot% = VAL(proLine$(25))
        clr% = VAL(proLine$(25))
        Title$ = proLine$(25)
CALL Win(left%, Right%, Top%, bot%, clr%, Title$)
END IF
IF progline$ = "mouseshow" THEN
        mouseShow
END IF
IF progline$ = "sleep" THEN
        dur% = VAL(proLine$(25))
        SLEEP dur%
END IF
IF progline$ = "mousebuff" THEN
        mouseBuff
END IF
IF progline$ = "clkd" THEN
        left% = VAL(proLine$(25))
        Right% = VAL(proLine$(25))
        Top% = VAL(proLine$(25))
        bot% = VAL(proLine$(25))
        button$ = proLine$(25)
        in% = VAL(proLine$(25))

IF clkd%(left%, Right%, Top%, bot%, button$, in%) = 1 THEN rescreen "Desktop", 0
END IF
IF progline$ = "ok" THEN
        OkNeeded = 1
        OkXLoc% = VAL(proLine$(25))
        OkYLoc% = VAL(proLine$(25))
        OkCenter% = VAL(proLine$(25))
' IF ButtonOk(OkXLoc%, OkYLoc%, OkCenter%) = 1 THEN ReScreen "Desktop", 0: EXIT DO
END IF
IF progline$ = "cancel" THEN
        CancelNeeded = 1
        CancelXLoc% = VAL(proLine$(25))
        CancelYLoc% = VAL(proLine$(25))
        CancelCenter% = VAL(proLine$(25))
' IF ButtonCancel(CancelXLoc%, CancelYLoc%, CancelCenter%) = 1 THEN ReScreen "Desktop", 0: EXIT DO
END IF
IF EOF(25) <> 0 THEN CLOSE 25: EXIT DO
LOOP
DO WHILE OkNeeded = 1 OR CancelNeeded = 1
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
ExecKey$ = INKEY$
KeyMouse ExecKey$
 IF OkNeeded = 1 THEN IF ButtonOk(OkXLoc%, OkYLoc%, OkCenter%) = 1 THEN : EXIT DO
 IF CancelNeeded = 1 THEN IF ButtonCancel(CancelXLoc%, CancelYLoc%, CancelCenter%) = 1 THEN rescreen "Desktop", 0: EXIT DO
LOOP
nocomp:
END SUB

SUB FirstRun (check%)
' This SUB will check to see if this is the first time you
' have run ChetOS.  It will create a chetos.dat file that
' contains info about the DOS Directory.
'
' Check = 0 means that ChetOS is just fine.
'
' Check = 1 means that it is just suppose to check for the number of
' times ChetOS has been run.
'
' Check = 2 means that ChetOS needs to get info.
'
IF check = 1 THEN
        OPEN "chetos.dat" FOR INPUT AS #1
        IF proLine$(1) = "0" OR proLine$(1) = "" THEN
                FirstRunReturn = 1
        END IF
        CLOSE #1
END IF
IF check = 2 THEN
        OPEN "chetos.dat" FOR OUTPUT AS #1
        PRINT "This is your first time running ChetOS."
        PRINT "ChetOS will have to get some info from you to run correctly."
        INPUT "Please enter the DOS Directory: ", dosdir$
        INPUT "Please enter your name (or nickname): ", nickname$
        PRINT "Thank you. Saving File and Starting ChetOS GUI"
                PRINT #1, "dosdir," + dosdir$
                PRINT #1, "nickname," + nickname$
                PRINT #1, "runnum,1"
                PRINT #1, "load,1"
        CLOSE #1
        SLEEP 2
END IF

END SUB

SUB GetBasics (what%)


IF what = 1 THEN
CALL JFont("Desktop", 15, 3, 1, 1.4)
GET (1, 1)-(57, 14), DeskTop
CALL JFont("Ok", 7, 60, 1, 1.4)
GET (59, 1)-(83, 14), okimg
CALL JFont("Cancel", 7, 85, 1, 1.4)
GET (85, 1)-(158, 14), cancelimg
END IF

IF what = 2 THEN
OPEN "desktop.icn" FOR OUTPUT AS #4
CALL JFont("Desktop", 15, 3, 1, 1.4)
GET (1, 1)-(57, 14), DeskTop%
1 PUT #4, , DeskTop%
CLOSE #4
OPEN "ok.icn" FOR OUTPUT AS #4
CALL JFont("Ok", 7, 60, 1, 1.4)
GET (59, 1)-(83, 14), okimg%
PUT #4, , okimg%
CLOSE #4
OPEN "cancel.icn" FOR OUTPUT AS #4
CALL JFont("Cancel", 7, 85, 1, 1.4)
GET (85, 1)-(158, 14), cancelimg%
PUT #4, , cancelimg%
CLOSE #4
END IF

IF what = 3 THEN
OPEN "desktop.icn" FOR INPUT AS #4
GET #4, , DeskTop%
CLOSE #4
OPEN "ok.icn" FOR INPUT AS #4
GET #4, , okimg%
CLOSE #4
OPEN "cancel.icn" FOR INPUT AS #4
GET #4, , cancelimg%
CLOSE #4
END IF


END SUB

SUB GetDesktop
IF gotdesktop = 0 THEN
OPEN "desktop.cfg" FOR INPUT AS #26
IF proLine$(26) <> "CFG" THEN DispErr "Error in Desktop Configuration File, reinstall ChetOS.", 0: MouseHide: CLOSE : MakeBack 1, 2, 1: GOTO contprog
DO
IF proLine$(26) = "icon" THEN
        icon(refidc).IconX = VAL(proLine$(26))
        icon(refidc).IconY = VAL(proLine$(26))
        icon(refidc).iname = proLine$(26)
        icon(refidc).ifile = proLine$(26)
        icon(refidc).hotkey = proLine$(26)
        refidc = refidc + 1
END IF
IF EOF(26) <> 0 THEN CLOSE 26: EXIT DO
LOOP
maxicon = refidc + 1
gotdesktop = 1
END IF

FOR Ref = 0 TO maxicon - 2
CALL Drawicon(icon(Ref).IconX, icon(Ref).IconY, icon(Ref).iname, icon(Ref).refid, 0)
NEXT
contprog:

END SUB

DEFSNG A-Z
SUB GetIcon
IconX = 1
IconY = 1
LINE (IconX, IconY)-(IconX + 33, IconY + 29), 15, B
LINE (IconX, IconY + 1)-(IconX + 34, IconY + 30), 15, B
LINE (IconX + 1, IconY + 7)-(IconX + 32, IconY + 7), 14

LINE (IconX + 3, IconY + 9)-(IconX + 9, IconY + 15), 2, B
LINE (IconX + 13, IconY + 9)-(IconX + 19, IconY + 15), 3, B
LINE (IconX + 24, IconY + 9)-(IconX + 30, IconY + 15), 8, B

LINE (IconX + 3, IconY + 18)-(IconX + 9, IconY + 25), 6, B
LINE (IconX + 13, IconY + 18)-(IconX + 19, IconY + 25), 9, B
LINE (IconX + 24, IconY + 18)-(IconX + 30, IconY + 25), 3, B
GET (1, 1)-(35, 32), iconimg%
CLS
IconX = 1
IconY = 1
LINE (IconX, IconY)-(IconX + 33, IconY + 29), 15, B, 40
LINE (IconX + 1, IconY + 1)-(IconX + 34, IconY + 30), 15, B, 40
LINE (IconX, IconY + 7)-(IconX + 33, IconY + 7), 14, , 40

LINE (IconX + 3, IconY + 9)-(IconX + 9, IconY + 15), 1, B, 40
LINE (IconX + 13, IconY + 9)-(IconX + 19, IconY + 15), 5, B, 40
LINE (IconX + 24, IconY + 9)-(IconX + 30, IconY + 15), 8, B, 40

LINE (IconX + 3, IconY + 18)-(IconX + 9, IconY + 25), 2, B, 40
LINE (IconX + 13, IconY + 18)-(IconX + 19, IconY + 25), 4, B, 40
LINE (IconX + 24, IconY + 18)-(IconX + 30, IconY + 25), 5, B, 40
GET (1, 1)-(35, 32), diconimg%
CLS
END SUB

DEFINT A-Z
SUB HandleError (ernum)
IF ernum = 53 THEN DispErr "File not found", 0: GOTO doneerror

doneerror:
END SUB

FUNCTION hConvert% (c%, p%, ch$)
' Converts the "locate" statement's coords to pixel coords (horisontally)
' C%=Chars
' P%=Pixels
' If ch$=c then convert from chars to pixels
' If ch$=p then convert from pixels to chars
IF ch$ = "c" THEN
hConvert% = INT(c% * 8)
END IF
IF ch$ = "p" THEN
hConvert% = INT(p% / 8)
END IF
END FUNCTION

DEFSNG A-Z
SUB hehe (left%, Right%, YLeft%, bot%, clr%)
' I wrote this sub so that I wouldn't have to write QbasicPaintIsGay everytime
CALL QbasicPaintIsGay(left%, Right%, YLeft%, bot%, clr%)
END SUB

DEFINT A-Z
SUB HitKey (co$)
LET co$ = UCASE$(co$)
IF co$ = "F" THEN aFMenu
IF co$ = "O" THEN aOMenu
IF co$ = "M" THEN aMMenu
IF co$ = "H" THEN aHMenu
IF co$ = "R" THEN rescreen "Desktop", 0
IF co$ = "V" THEN InternalGame (1)
IF co$ = "S" THEN ScreenSaver
KeyMouse (co$)
END SUB

SUB IconCreate
MouseHide
CALL Win(10, 300, 30, 140, 15, "New Group")
dbox 15, 170, 63, 80, 15, 0, 0, 0
LOCATE 5, 3: PRINT "Name:"
comx = 7
LOCATE 5, comx + 1: PRINT CHR$(219)
count = 0
mouseShow
in$ = ""
inp$ = ""
ine$ = ""
DO
IF inp$ = "" OR LEN(inp$) = 0 THEN inp$ = INKEY$
IF inp$ = "" THEN GOTO DoneProcess
IF ASC(inp$) = 13 THEN
   IF in$ <> "" THEN LET ine$ = in$
   StringSet = 1
   LOCATE 5, comx + 1: PRINT " ": GOTO DoneProcess
END IF
count = count + 1
IF count < 0 THEN count = 0
IF count < 9 THEN gotohello = 0
IF count >= 9 THEN
        LOCATE 5, comx
        PRINT CHR$(219); " "
        
        IF ASC(inp$) <> 8 THEN inp$ = ""
        count = 8
        comx = 16
        LET gotohello = 1
END IF
IF LEN(inp$) > 0 THEN
        IF ASC(inp$) = 8 THEN
                IF comx <= 7 THEN LOCATE 20, 10: PRINT comx: GOTO DoneProcess
                LOCATE 5, comx: PRINT CHR$(219); " "
                inp$ = ""
                in$ = LEFT$(in$, (LEN(in$) - 1))
                count = count - 2
                GOTO DoneProcess
        IF gotohello = 1 THEN GOTO DoneProcess
        END IF
IF gotohello = 1 THEN GOTO DoneProcess
IF ASC(inp$) <> 8 THEN LET in$ = in$ + inp$
IF ASC(inp$) <> 8 THEN LET comx = comx + 1
IF ASC(inp$) <> 8 THEN LOCATE 5, comx: PRINT inp$: LOCATE 5, comx + 1: PRINT CHR$(219)
END IF
DoneProcess:
' LOCATE 20, 5: PRINT comx, in$, inp$, count
IF StringSet = 1 THEN EXIT DO
inp$ = ""
        IF inp$ = "" THEN inp$ = INKEY$
timedate (t%)
        IF inp$ = "" THEN inp$ = INKEY$
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
        IF inp$ = "" THEN inp$ = INKEY$
IF ButtonOk(80, 100, 0) = 1 THEN EXIT DO
        IF inp$ = "" THEN inp$ = INKEY$
IF ButtonCancel(170, 100, 0) = 1 THEN EXIT DO
        IF inp$ = "" THEN inp$ = INKEY$
lb% = -1
        IF inp$ = "" THEN inp$ = INKEY$
LOOP
peakx = 0
PeakY = 0

FOR Ref = 0 TO maxicon - 2
IF icon(Ref).IconX > peakx THEN peakx = icon(Ref).IconX
NEXT

FOR Ref = 0 TO maxicon - 2
IF icon(Ref).IconY > PeakY THEN PeakY = icon(Ref).IconY
NEXT
'IF peakx = 390 THEN
'if p
        
'Icon(ref).icony, Icon(ref).iname, Icon(ref).refid, 0)

peakx = peakx + 50
END SUB

DEFSNG A-Z
SUB InitMouse
' Puts HEX info into Mouse$
mouse$ = SPACE$(57)
FOR i% = 1 TO 57
  READ a$
  h$ = CHR$(VAL("&H" + a$))
  MID$(mouse$, i%, 1) = h$
NEXT i%
  DEF SEG = VARSEG(mouse$)
mouseok = 1
StartMouse
END SUB

DEFINT A-Z
SUB InitProg
' Clears memory and sets inital varibles
RESTORE
CLOSE
RANDOMIZE TIMER
IF testStart = 1 THEN GOTO noreload
InitScreen
GetIcon

' Get standard ChetOS values (BASIC OPERATION)

OPEN "chetos.cfg" FOR INPUT AS #1
DO
IF proLine$(1) = "mode" THEN mode$ = proLine$(1)
IF proLine$(1) = "ver" THEN ver! = VAL(proLine$(1))
IF proLine$(1) = "redraw" THEN redra = VAL(proLine$(1))
IF proLine$(1) = "created" THEN created$ = proLine$(1)
IF proLine$(1) = "fastload" THEN fastload = VAL(proLine$(1))
IF EOF(1) <> 0 THEN CLOSE #1: EXIT DO
LOOP
' Temporary CONFIG Overrides

' Get screen saver values

OPEN "SSaver.cfg" FOR INPUT AS #1
DO
IF proLine$(1) = "enabled" THEN SaverEnabled = VAL(proLine$(1))
IF proLine$(1) = "active" THEN ActiveSaver = VAL(proLine$(1))
IF proLine$(1) = "delay" THEN SaverDelay = VAL(proLine$(1))
IF EOF(1) <> 0 THEN CLOSE #1: EXIT DO
LOOP
' Get colors for desktop (Needed for background)

OPEN "desktop.cfg" FOR INPUT AS #26
IF proLine$(26) <> "CFG" THEN DispErr "Error in Desktop Configuration File, reinstall ChetOS.", 0: MouseHide: CLOSE : MakeBack 1, 2, 1: GOTO usedefaults
DO
IF proLine$(26) = "deskclr1" THEN deskclr1$ = proLine$(26)
IF proLine$(26) = "deskclr2" THEN deskclr2$ = proLine$(26)
IF EOF(26) <> 0 THEN CLOSE #26: EXIT DO
LOOP
deskclr1% = VAL(deskclr1$)
deskclr2% = VAL(deskclr2$)
usedefaults:
IF deskclr1$ = "" THEN deskclr1% = 1    ' If values are 0 then set default
IF deskclr2$ = "" THEN deskclr2% = 2

MakeBack 3, 1, 0
LINE (167, 150)-(484, 250), 0, BF
LINE (167, 150)-(484, 250), 15, B
CALL CLocate(11, 999, "Starting ChetOS 2000", 0, "", 0)
CALL CLocate(13, 999, "Created:", 0, created$, 0)
CALL CLocate(15, 999, "Clearing Required Memory", 0, "", 0)
Delay 15
InitStats
RunSys
tempx = 320
tempy = 200
GetBasics 1
noreload:
END SUB

DEFSNG A-Z
SUB InitScreen
' Sets default screen settings
' WINDOW SCREEN (0, 0)-(639, 480)
SCREEN 12
CLS
COLOR 15
END SUB

DEFINT A-Z
SUB InitStats
OPEN "chetos.dat" FOR INPUT AS #2
        IF proLine$(2) = "dosdir" THEN
                dosdir$ = proLine$(2)
        END IF
        IF proLine$(2) = "nickname" THEN
                nickname$ = proLine$(2)
        END IF
        IF proLine$(2) = "runnum" THEN
                runnum = VAL(proLine$(2))
        END IF
        IF proLine$(2) = "load" THEN
                load = VAL(proLine$(2))
        END IF
CLOSE #2
OPEN "chetos.dat" FOR OUTPUT AS #2
        PRINT #2, "dosdir," + dosdir$
        PRINT #2, "nickname," + nickname$
        PRINT #2, "runnum," + STR$(runnum + 1)
        PRINT #2, "load,1"
CLOSE #2
inittime$ = TIME$
initdate$ = DATE$
END SUB

DEFSNG A
SUB InternalGame (game)
IF game = 1 THEN
        MouseHide
        RESTORE jezzdata

        DIM BALL(100)
        DIM VERTARROW(60)
        DIM HORZARROW(75)
        dbox 39, 601, 43, 340, 15, 1, 0, 0
        ' Start Screen
        LOCATE 10, 35: PRINT "JEZZBALL"
        LOCATE 12, 24: PRINT "HIT ENTER OR LEFT CLICK TO START!"
        LOCATE 14, 24: PRINT "HIT ESCAPE OR RIGHT CLICK TO EXIT"
        MouseRange 40, 44, 600, 339
        mouseShow
50
        CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
        STRT$ = INKEY$
        KeyMouse STRT$
        IF STRT$ = CHR$(27) THEN GOTO donejezz
        IF lb% = -1 THEN lb% = 0: MouseHide: mouseBuff: GOTO 142
        IF STRT$ = CHR$(13) THEN GOTO 142
        IF rb% = -1 THEN rb% = 0: MouseHide: mouseBuff: GOTO donejezz
        GOTO 50
142
        ' Ball
        FOR GameTempY = 71 TO 80
                FOR GameTempX = 71 TO 80
                        READ z
                        PSET (GameTempX, GameTempY), z
                NEXT GameTempX
        NEXT GameTempY
        GET (70, 70)-(80, 80), BALL
        ' Vertical Arrow
        FOR GameTempY = 71 TO 82
                FOR GameTempX = 71 TO 75
                        READ z
                        PSET (GameTempX, GameTempY), z
                NEXT GameTempX
        NEXT GameTempY
        GET (70, 70)-(75, 82), VERTARROW
        ' Horisontal Arrow
        FOR GameTempY = 71 TO 75
                FOR GameTempX = 71 TO 85
                        READ z
                        PSET (GameTempX, GameTempY), z
                NEXT GameTempX
        NEXT GameTempY
        GET (70, 70)-(85, 75), HORZARROW
        tempx = 280
        tempy = 135
        mousePut 280, 135

' Start game
10
        time = 4500
        GameTempX = 240: GameTempY = 95: Q = 1: z = 1
        h = 280: i = 135: M = 0: S = 1

        ' Set Boundaries
        left = 1: Right = 560: Top = 1: Bottom = 270
        ' +++++++++++++++++++++++++++++++++++++++++++++++++
       
        MouseRange left + 2, Top - 1, Right - 12, Bottom - 17
        MouseHide
        LIVES = 5
        SCREEN 12, 0
        VIEW (40, 70)-(600, 335), 0, 15
        mousePut h, i
0
        IF S = 1 AND M = 0 THEN
        PUT (h, i), VERTARROW
        ELSEIF S = -1 AND M = 0 THEN
        PUT (h - 4, i + 4), HORZARROW
        END IF
        LOCATE 4, 7
        PRINT "JEZZBALL"
        BT = (Bottom - Top) / 10
        RL = (Right - left) / 10
        aBox = (BT) * (RL)
        Percent! = ((151200 - (aBox * 100)) / 151200) * 100
        IF INT(Percent!) >= 90 THEN GOTO ending
        LOCATE 4, 25: PRINT "PERCENT = "; RTRIM$(LTRIM$(STR$((INT(Percent!))))); "%"
        IF LIVES = 0 THEN GOTO ending
        LOCATE 4, 45
        PRINT "LIVES = "; LIVES
        IF time = 0 THEN GOTO ending
        GOSUB BOUNCE


        ' Key check
        k$ = INKEY$
        CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
        KeyMouse k$
        h = MouseX%
        i = MouseY%
        IF lb% = -1 THEN mouseBuff: k$ = "i"
        IF rb% = -1 THEN mouseBuff: S = S * -1
        
        IF k$ = "" THEN
                GOTO check
        ELSEIF (k$ = "4" OR RIGHT$(k$, 1) = "K") AND S = 1 AND h > left + 1 THEN
                h = h - 3
        ELSEIF (k$ = "4" OR RIGHT$(k$, 1) = "K") AND S = -1 AND h > left + 5 THEN
                h = h - 3
        ELSEIF (k$ = "6" OR RIGHT$(k$, 1) = "M") AND S = 1 AND h < Right - 7 THEN
                h = h + 3
        ELSEIF (k$ = "6" OR RIGHT$(k$, 1) = "M") AND S = -1 AND h < Right - 15 THEN
                h = h + 3
        ELSEIF (k$ = "8" OR RIGHT$(k$, 1) = "H") AND S = 1 AND i > Top + 1 THEN
                i = i - 3
        ELSEIF (k$ = "8" OR RIGHT$(k$, 1) = "H") AND S = -1 AND i > Top - 3 THEN
                i = i - 3
        ELSEIF (k$ = "2" OR RIGHT$(k$, 1) = "P") AND S = 1 AND i < Bottom - 12 THEN
                i = i + 3
        ELSEIF (k$ = "2" OR RIGHT$(k$, 1) = "P") AND S = -1 AND i < Bottom - 11 THEN
                i = i + 3
        ELSEIF (k$ = "5" OR k$ = "S" OR k$ = "s") AND S = 1 AND h < Right - 13 AND h > left + 3 THEN
                S = -S
        ELSEIF (k$ = "5" OR k$ = "S" OR k$ = "s") AND S = -1 AND i > Top - 1 AND i < Bottom - 10 THEN
                S = -S
        END IF
skipgaystuff:
        IF k$ = CHR$(27) THEN END
       
        IF k$ = "I" OR k$ = "i" OR k$ = CHR$(13) THEN
        IF S = 1 THEN
        BTop = i + 7: BBtm = i + 7: M = 1: VBGN = i + 7
V:
        LINE (h + 2, VBGN)-(h + 4, BTop), 4, BF
        LINE (h + 2, VBGN)-(h + 4, BBtm), 9, BF
        IF GameTempX + 10 >= h + 2 AND GameTempX <= h + 4 AND GameTempY <= BBtm AND GameTempY >= BTop THEN
                M = 0
                LIVES = LIVES - 1
                LINE (h + 2, BBtm)-(h + 4, BTop), 0, BF
                GOTO 0
        END IF
        IF BTop <= Top AND BBtm >= Bottom THEN
        M = 0
        IF GameTempX > h THEN
                LINE (left - 1, Top - 2)-(h + 4, Bottom + 2), 15, BF
                left = h + 6
                h = h + 5
        ELSE
                LINE (Right, Top - 2)-(h, Bottom + 2), 15, BF
                Right = h - 1
                h = h - 6
        END IF
' -----------------**************************----------------
       
        MouseRange left + 3, Top - 1, Right - 12, Bottom - 16
        GOTO 0
        ELSE
        IF BTop > Top THEN BTop = BTop - 1
        IF BBtm < Bottom + 2 THEN BBtm = BBtm + 1
        END IF
        MouseRange left + 3, Top - 1, Right - 12, Bottom - 16
        GOSUB BOUNCE
        ELSE
        BLft = h + 4: BRgt = h + 4: M = 2: HBGN = h + 4
HNTL:
        LINE (BLft, i + 5)-(HBGN, i + 7), 4, BF
        LINE (BRgt, i + 5)-(HBGN, i + 7), 9, BF
        IF GameTempY + 10 >= i + 6 AND GameTempY <= i + 6 AND GameTempX <= BRgt AND GameTempX >= BLft THEN
                M = 0
                LIVES = LIVES - 1
                LINE (BLft, i + 5)-(BRgt, i + 7), 0, BF
                GOTO 0
        END IF
        IF INT(BLft) <= left AND INT(BRgt) >= Right - 1 THEN
        M = 0
        IF GameTempY > i THEN
                LINE (left - 1, Top - 2)-(Right, i + 7), 15, BF
                Top = i + 10
                i = i + 5
        ELSE
                LINE (left - 1, Bottom + 2)-(Right, i + 5), 15, BF
                Bottom = i + 2
                i = i - 7
        END IF
        MouseRange left + 3, Top - 1, Right - 12, Bottom - 16
        GOTO 0
        ELSE
        IF BLft > left THEN BLft = BLft - 1.5
        IF BRgt < Right - 1 THEN BRgt = BRgt + 1.5
        END IF
        GOSUB BOUNCE
        END IF
        MouseRange left + 3, Top - 1, Right - 12, Bottom - 16
        END IF


        REM THESE 3 LINE DETERMINE THE PROGRAM MODE
        REM MODE 0 IS NORMAL PLAY
        REM MODE 1 DRAWS THE ANIMATED VERTICAL BAR
        REM MODE 2 DRAWS THE ANIMATED HORIZONTAL BAR
check:
        IF M = 0 THEN GOTO 0
        IF M = 1 THEN GOTO V
        IF M = 2 THEN GOTO HNTL

        REM THIS SECTION ANIMATES THE BALL
BOUNCE:
        PUT (GameTempX, GameTempY), BALL
        IF GameTempX >= Right - 12 OR GameTempX <= left + 1 THEN
                Q = -Q
        END IF
        IF GameTempY >= Bottom - 10 OR GameTempY <= Top + 2 THEN
                z = -z
        END IF
        IF time = 30 THEN time = 4500
        OLDX = GameTempX
        OLDY = GameTempY
        OLDH = h: OLDI = i
       
        holdgame = holdgame + 1
        IF holdgame = 5 THEN SOUND 0, 1: holdgame = 0: timeupdategame = timeupdategame + 1
        IF timeupdategame = 5 THEN timedate (t%)
       
        LINE (OLDX, OLDY)-(OLDX + 10, OLDY + 10), 0, BF
        IF S = 1 THEN
                LINE (OLDH, OLDI)-(OLDH + 5, OLDI + 12), 0, BF
        ELSE
                LINE (OLDH - 4, OLDI + 4)-(OLDH + 11, OLDI + 10), 0, BF
        END IF
        GameTempX = GameTempX + (3 * Q)
        GameTempY = GameTempY + (3 * z)
        LOCATE 4, 58
        IF time = 0 THEN GOTO ending
        PRINT "TIME LEFT = "; time
        time = time - 1
        RETURN

        REM THIS MAKES THE CLOSING SCREEN
ending:
        MouseHide
        VIEW
                dbox 39, 601, 43, 340, 15, 1, 0, 0
        IF time = 0 THEN
                LOCATE 9, 25
                PRINT "TIME'S UP!"
        ELSEIF LIVES = 0 THEN
                LOCATE 9, 25
                PRINT "YOU DIED!"
        ELSEIF Percent <= 75 THEN
                LOCATE 9, 25
                PRINT "LEVEL COMPLETED"
        END IF
        BT = (Bottom - Top) / 10
        RL = (Right - left) / 10
        aBox = (BT) * (RL)
        Percent! = ((151200 - (aBox * 100)) / 151200) * 100
        LOCATE 11, 25
        PRINT "PERCENT OF BOARD COVERED "; INT(Percent!); "%"
        LOCATE 12, 25
        PRINT "YOUR SCORE IS "; INT(Percent!) * (100 + time)
        LOCATE 14, 25
        PRINT "WOULD YOU LIKE TO PLAY AGAIN?"
MouseRange 0, 0, 636, 477
mouseShow
mouseShow
mouseShow
30
        CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
        PlayS$ = INKEY$
        KeyMouse PlayS$
        IF ButtonOk(223, 237, 0) = 1 THEN GOTO 10
        IF ButtonCancel(345, 237, 0) = 1 THEN PlayS$ = "C"
        IF PlayS$ = CHR$(13) THEN GOTO 10
        IF PlayS$ = "Y" OR PlayS$ = "y" THEN GOTO 10
        IF PlayS$ = "N" OR PlayS$ = "n" THEN GOTO donejezz
        IF PlayS$ = CHR$(27) OR PlayS$ = "C" THEN
                cancelthere = 0
                okthere = 0
                GOTO donejezz
        END IF
        IF clkd(556, 634, 466, 477, "l", 1) = 1 THEN
                mouseBuff
                IF t% = 0 THEN t% = 1: yy4% = 0: GOTO endgametime
                IF t% = 1 THEN t% = 0: yy4% = 0: GOTO endgametime
        END IF
endgametime:
        timedate (t%)
GOTO 30
donejezz:
rescreen "Desktop", 0
MouseRange 0, 0, 636, 477
mouseShow
END IF

END SUB

DEFINT A
'                    /-------------------------- Text
'                  /  /------------------------- Color
'                /  /  /------------------------ XCoord Higher is righter
'              /  /  /           /-------------- YCoord Higher is lower
'            /  /   /           /            /-- Size
'           V  V  V            V            V
SUB JFont (a$, c, XCoordinate, YCoordinate, size!)
YCoordinate = INT(YCoordinate / size!)   'Prevent ballooning of YCoordinates
                                         'that is a result of using
                                         'size values larger than 1 for size

IF XCoordinate = -1 THEN
        XCoordinate = 190 - INT(LEN(a$) / 2)
END IF
startx = XCoordinate               'set Starting X-Val for character drawing

FOR e = 1 TO LEN(a$)

   B$ = MID$(a$, e, 1)     ' read each character of the string
   a = ASC(B$)             ' get ASCII values of each character

        FOR x = 1 TO 8
         FOR y = 1 TO 6

            SELECT CASE charset(a, x, y)       'use ASCII value (a) to point
               CASE 0: col = 0                 ' Don't draw pixel
               CASE 1: col = c                 ' Draw pixel
            END SELECT

          IF col <> 0 THEN        'Draw a pixel!
           LINE (startx + pixelsright, (x + YCoordinate) * size!)-(startx + pixelsright + (size! - 1), ((x + YCoordinate) * size!) + (size! - 1)), col, BF
          END IF

          startx = startx + size!     'Set starting X-value for next pixel
       
        NEXT y
      
       startx = XCoordinate          'reset startx for next line of pixels
    
     NEXT x
   pixelsright = pixelsright + (6 * size!)   ' add pixels for next character

NEXT e

END SUB

SUB KeyMouse (kMouse$)
IF kMouse$ = "1" OR kMouse$ = "2" OR kMouse$ = "3" OR kMouse$ = "4" OR kMouse$ = "5" OR kMouse$ = "6" OR kMouse$ = "7" OR kMouse$ = "8" OR kMouse$ = "9" OR kMouse$ = "0" OR kMouse$ = "." THEN
        IF kMouse$ = "4" THEN tempx = tempx - 5
        IF kMouse$ = "6" THEN tempx = tempx + 5
        IF kMouse$ = "8" THEN tempy = tempy - 5
        IF kMouse$ = "2" THEN tempy = tempy + 5
        IF kMouse$ = "5" THEN
                LOCATE 16, 2: INPUT "X%: ", tempx%
                LOCATE 17, 2: INPUT "Y%: ", tempy%
                mousePut tempx%, tempy%
        END IF
        IF kMouse$ = "7" THEN tempx = tempx - 5: tempy = tempy - 5
        IF kMouse$ = "9" THEN tempx = tempx + 5: tempy = tempy - 5
        IF kMouse$ = "1" THEN tempx = tempx - 5: tempy = tempy + 5
        IF kMouse$ = "3" THEN tempx = tempx + 5: tempy = tempy + 5

IF tempx < MRLeft THEN tempx = MRLeft
IF tempx > MRRight THEN tempx = MRRight
IF tempy < MRTop THEN tempy = MRTop
IF tempy > MRBot THEN tempy = MRBot

IF tempx >= MRLeft AND tempx <= MRRight AND tempy >= MRTop AND tempy <= MRBot THEN mousePut tempx%, tempy%
        IF kMouse$ = "0" THEN lb% = -1
        IF kMouse$ = "." THEN rb% = -1
END IF

END SUB

SUB LoadGroup (ifile$)
OPEN LTRIM$(RTRIM$(ifile$)) + ".gcf" FOR INPUT AS #26
IF proLine$(26) <> "GCFG" THEN DispErr "Error in Group Control File, recreate group. (Contents may be lost)", 0: CLOSE : GOTO contgroup
DO
MouseHide
IF proLine$(26) = "win" THEN
        left = VAL(proLine$(26))
        Right = VAL(proLine$(26))
        Top = VAL(proLine$(26))
        bot = VAL(proLine$(26))
        text$ = proLine$(26)
        bxcolor = VAL(proLine$(26))
        CALL Win(left, Right, Top, bot, bxcolor, text$)
END IF
IF proLine$(26) = "gicon" THEN
        gicon(refidc).IconX = VAL(proLine$(26))
        gicon(refidc).IconY = VAL(proLine$(26))
        gicon(refidc).iname = proLine$(26)
        gicon(refidc).ifile = proLine$(26)
        gicon(refidc).refid = refidc
        refidc = refidc + 1
END IF
IF EOF(26) <> 0 THEN CLOSE 26: EXIT DO
maxgicon = refidc
LOOP
mouseShow
FOR Ref = 0 TO maxgicon
CALL Drawicon(gicon(Ref).IconX, gicon(Ref).IconY, gicon(Ref).iname, gicon(Ref).refid, 0)
NEXT
contgroup:
END SUB

SUB MakeBack (clr%, clr2%, hidemouse)
IF hidemouse = 1 THEN MouseHide
ea% = 0
eb% = 634
ec% = 318
ed% = 316
Top% = 26
bot% = 462
DO
ea% = ea% + 2
eb% = eb% - 2
ec% = ec% - 2
ed% = ed% + 2
IF ea% >= 161 THEN EXIT DO
'Starts at Left heads Right
LINE (ea%, Top%)-(ea%, bot%), clr%
LINE (ea% + 1, Top%)-(ea% + 1, bot%), clr2%
'Starts at Right heads Left
LINE (eb%, Top%)-(eb%, bot%), clr%
LINE (eb% + 1, Top%)-(eb% + 1, bot%), clr2%
'Starts at Center heads Right
LINE (ec%, Top%)-(ec%, bot%), clr%
LINE (ec% + 1, Top%)-(ec% + 1, bot%), clr2%
'Starts at Middle heads Right
LINE (ed%, Top%)-(ed%, bot%), clr%
LINE (ed% + 1, Top%)-(ed% + 1, bot%), clr2%
LOOP
IF hidemouse = 1 THEN mouseShow
END SUB

REM $DYNAMIC
DEFSNG A-Z
SUB mouseBuff
' Waits for a user to release the button before continuing
DO
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF lb% = 0 AND rb% = 0 THEN EXIT DO
LOOP
END SUB

REM $STATIC
SUB MouseDriver (ax%, bx%, cx%, dx%)
' Mouse code that I didn't write.
IF mouseok = 1 THEN
CALL Absolute(ax%, bx%, cx%, dx%, SADD(mouse$))
END IF
END SUB

SUB MouseHide
' Mouse code that I didn't write, It hides the mouse pointer
        MouseDriver 2, 0, 0, 0
END SUB

FUNCTION mouseInit%
' Mouse code that I didn't write.
  MouseDriver 0, 0, 0, 0
  mouseInit% = 0
END FUNCTION

DEFINT A-Z
SUB mousePut (MouseX%, MouseY%)
        ax% = 4
        cx% = MouseX%
        dx% = MouseY%
        MouseDriver ax%, 0, cx%, dx%
END SUB

DEFLNG A-Z
SUB MouseRange (X1%, Y1%, X2%, Y2%)
  MRLeft% = X1%
  MRRight% = X2%
  MRTop% = Y1%
  MRBot% = Y2%
 
  ax% = 7
  cx% = X1%
  dx% = X2%
MouseDriver ax%, 0, cx%, dx%
  ax% = 8
  cx% = Y1%
  dx% = Y2%
  MouseDriver ax%, 0, cx%, dx%
END SUB

DEFSNG A-Z
SUB mouseShow
' Mouse code that I didn't write, It shows the mouse pointer
        MouseDriver 1, 0, 0, 0
END SUB

SUB MouseStatus (lb%, rb%, MouseX%, MouseY%)
' Mouse code that I didn't write, It gets the coord's for the mouse.
  MouseDriver 3, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  rb% = ((bx% AND 2) <> 0)
  MouseX% = cx%
  MouseY% = dx%
END SUB

FUNCTION proLine$ (fil%)
DO
        IF EOF(fil%) <> 0 THEN EXIT DO
        INPUT #fil%, progline$
        IF progline$ <> "" THEN EXIT DO
LOOP
proLine$ = progline$
'PRINT progline$; "    ";
END FUNCTION

SUB QbasicPaintIsGay (left%, Right%, YLeft%, bot%, clr%)
' I wrote this because the Paint function didn't work for my purposes
LINE (left%, YLeft%)-(Right%, bot%), clr%, BF
END SUB

SUB Readbmp (data$, ys%, ye%, xe%)
' BMP Code that I didn't write, it displays a bmp image (16 colors)
data$ = data$ + ".bmp"
IF LTRIM$(RTRIM$(data$)) = "" THEN END
CLOSE
IF xe% = 1 THEN LET xe% = 630
OPEN data$ FOR BINARY AS #1

table$ = INPUT$(54, #1)
DIM table&(30)
DEF SEG = VARSEG(table&(1))
pointer% = VARPTR(table&(1))

FOR x% = 0 TO 51
 POKE pointer% + x%, ASC(MID$(table$, x% + 3, 1))
NEXT
DEF SEG

IF (table&(5) < 321) AND (table&(6) < 201) THEN
   SCREEN 12
ELSE
   SCREEN 12
END IF
thecolors$ = INPUT$(table&(3) - 54, #1)
'x% = xc%
DEF SEG = VARSEG(Pal&)
pointer% = VARPTR(Pal&)
FOR x% = 63 TO 0 STEP 4
 POKE pointer%, (ASC(MID$(thecolors$, x% + 3, 1))) \ 4
 POKE pointer% + 1, (ASC(MID$(thecolors$, x% + 2, 1))) \ 4
 POKE pointer% + 2, (ASC(MID$(thecolors$, x% + 1, 1))) \ 4
 POKE pointer% + 3, 0
PALETTE x% \ 4, Pal&
NEXT
DEF SEG
IF ye% = 1 OR ye% = 0 THEN LET ye% = -80
y% = ys%
DO
data$ = INPUT$((((table&(5) - 1) OR 7) + 1) \ 2, #1)
    IF (table&(5) \ 2) < LEN(data$) THEN
       linelength% = table&(5) \ 2
    ELSE
       linelength% = LEN(data$)
    END IF
    IF linelength% >= xe% THEN LET linelength% = xe%
    FOR x% = 1 TO linelength% 'STEP xc%
      pixel% = ASC(MID$(data$, x%, 1))
      PSET (x% * 2 + 1, y%), pixel% AND 15
      PSET (x% * 2, y%), pixel% \ 17
     NEXT
    IF ye% = y% THEN GOTO donebmp
        y% = y% + 1
LOOP UNTIL EOF(1) OR y% = -80
donebmp:
END SUB

SUB Reboot
'cwin (Offs%, top%, bot%, clr%, Title$)
CWin 130, 130, 240, 15, "Reboot"
LOCATE 11, 27: PRINT "Warning!!! This will destroy"
LOCATE 12, 29: PRINT "all data. Are You Sure?"
DO
IF ButtonOk(225, 210, 0) = 1 THEN OUT &H64, &HFE: EXIT DO
IF ButtonCancel(340, 210, 0) = 1 THEN EXIT DO
co$ = INKEY$: IF co$ = CHR$(27) THEN EXIT DO
timedate (t%)
LOOP
END SUB

DEFINT A-Z
SUB rescreen (what$, full%)
' Redraws the screen
lb% = 0
x% = 0
y% = 0
       
        OPEN "desktop.cfg" FOR INPUT AS #26
        IF proLine$(26) <> "CFG" THEN DispErr "Error in Desktop Configuration File, reinstall ChetOS.", 0: MouseHide: CLOSE : MakeBack 1, 2, 1: GOTO DefaultColor
        DO
        IF proLine$(26) = "deskclr1" THEN deskclr1$ = proLine$(26)
        IF proLine$(26) = "deskclr2" THEN deskclr2$ = proLine$(26)
        IF EOF(26) <> 0 THEN CLOSE #26: EXIT DO
        LOOP
deskclr1% = VAL(deskclr1$)
deskclr2% = VAL(deskclr2$)
DefaultColor:
IF deskclr1$ = "" THEN deskclr1% = 1    ' If values are 0 then set default
IF deskclr2$ = "" THEN deskclr2% = 2

IF full% = 0 THEN GOTO botofre

MouseHide
CLS
MakeBack deskclr1%, deskclr2%, 1
' Top area cleared
yy4% = 0
CALL JFont("F", 9, 10, 2, 1.4)
CALL JFont("O", 9, 64, 2, 1.4)
CALL JFont("M", 9, 185, 2, 1.4)
CALL JFont("H", 9, 593, 2, 1.4)
CALL JFont("ile", 15, 16, 4, 1.4)
CALL JFont("ptions", 15, 74, 3, 1.4)
CALL JFont("enus", 15, 195, 3, 1.4)
CALL JFont("elp", 15, 603, 3, 1.4)
CALL JFont("~", 2, 9, 15, 1)
CALL JFont("~", 2, 64, 15, 1)
CALL JFont("~", 2, 185, 15, 1)
CALL JFont("~", 2, 593, 15, 1)
' Top area cleared
dbox 1, 635, 463, 463, 0, 1, 0, 0
' Main Box
dbox 0, 635, 25, 478, 7, 0, 2, 0
' Bottom Boxed
dbox 1, 635, 463, 478, 7, 0, 0, 0
CALL JFont("Active: ", 15, 4, 466, 1.4)
gotdesktop = 0
GetDesktop
timedate (t%)
botofre:
IF full% = 0 THEN MouseHide: MakeBack deskclr1, deskclr2, 1
IF full% = 0 THEN GetDesktop
IF what$ <> "" THEN ZActive what$
mouseShow
END SUB

SUB RunSys
RANDOMIZE TIMER
OPEN "fontdata.dat" FOR INPUT AS #3
FOR a = 1 TO 126
IF fastload = 1 THEN GOTO nogo1
r = r + 2
IF r = 10 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 10 THEN CALL CLocate(15, 999, "Starting System Engine", 0, "", 0): Delay 30
IF r = 50 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 50 THEN CALL CLocate(15, 999, "Getting ChetOS Config", 0, "", 0): Delay 10
IF r = 100 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 100 THEN CALL CLocate(15, 999, "Allocating Memory to OS", 0, "", 0): Delay 10
IF r = 150 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 150 THEN CALL CLocate(15, 999, "Allocating Memory to Video", 0, "", 0): Delay 10
IF r = 200 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 200 THEN CALL CLocate(15, 999, "Enabling Linear Graphics", 0, "", 0): SystemTest (1)
IF r = 250 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 250 THEN CALL CLocate(15, 999, "Enabling Angular Graphics", 0, "", 0): SystemTest (2)
nogo1:
        FOR x = 1 TO 8
                FOR y = 1 TO 6
                        INPUT #3, B
                        charset(a, x, y) = B  'loads font data into 3-D array.
                NEXT y
        NEXT x
NEXT a
'GOTO nogo2
r = 299
DO UNTIL r > 308
r = r + 1
IF r = 300 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 300 THEN CALL CLocate(15, 999, "Testing Graphic Modes", 0, "", 0): SystemTest (3): Delay 10: GOTO donedisp
IF r = 301 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 301 THEN CALL CLocate(15, 999, "Initializing Mouse", 0, "", 0): Delay 10: GOTO donedisp
IF r = 302 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 302 THEN CALL CLocate(15, 999, "Testing Mouse", 0, "", 0): CALL InitMouse: SystemTest (4): GOTO donedisp
IF r = 303 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 303 THEN CALL CLocate(15, 999, "Testing Graphing Capabilities", 0, "", 0): SystemTest (5): GOTO donedisp
IF r = 304 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 304 THEN CALL CLocate(15, 999, "Creating Wireframe Image of GUI", 0, "", 0): SystemTest (6): GOTO donedisp
IF r = 305 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 305 THEN CALL CLocate(15, 999, "Activating Security System", 0, "", 0): Delay 20: GOTO donedisp
IF r = 306 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 306 THEN CALL CLocate(15, 999, "Creating GUI in Virtual Memory", 0, "", 0): SystemTest (7): GOTO donedisp
IF r = 307 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 307 THEN CALL CLocate(15, 999, "Welcome to ChetOS 2000", 0, "", 0): SLEEP 1: GOTO donedisp
IF r = 308 THEN CALL CLocate(15, 999, "                                ", 0, "", 0)
IF r = 308 THEN CALL CLocate(15, 999, "Standby for GUI Placement...", 0, "", 0): GOTO donedisp
donedisp:
LOOP
nogo2:
CLOSE #3
IF fastload = 1 THEN GOTO nogo3
OPEN "chetboot.log" FOR OUTPUT AS #2
PRINT #2, "ChetOS Boot Log for "; DATE$
PRINT #2, ""
PRINT #2, ""
PRINT #2, "System Checklist:"
PRINT #2, ""
PRINT #2, "#Initializing Display                    [PASSED]"
PRINT #2, "#Getting Fontdata                        [PASSED]"
PRINT #2, "#Allocating Memory To OS                 [PASSED]"
PRINT #2, "#Allocating Memory To Video Display      [PASSED]"
PRINT #2, "#Setting Up GUI                          [PASSED]"
PRINT #2, "#Dictating Color Codes                   [PASSED]"
PRINT #2, "#Testing System Integrity                [PASSED]"
PRINT #2, "#Testing GUI                             [PASSED]"
PRINT #2, "!Deleting ChetTemp Files                X [FAILED]"
PRINT #2, "!Initializing ChetScript Engine         ? [ERRORS]"
PRINT #2, "#Reading Icon DataFile                   [PASSED]"
PRINT #2, "#Calculating Icon Placement              [PASSED]"
PRINT #2, "#Initializing Mouse                      [PASSED]"
PRINT #2, "#Testing Mouse                           [PASSED]"
PRINT #2, "#Enabling Linear Designing               [PASSED]"
PRINT #2, "#Enabling Angular Designing              [PASSED]"
PRINT #2, "#Testing Graphic Capibilities            [PASSED]"
PRINT #2, "!Starting System                        ? [ERRORS]"
PRINT #2, "#Detecting Modem                         [PASSED]"
PRINT #2, "#Switching To Screen 12                  [PASSED]"
PRINT #2, "#Clearing Screen                         [PASSED]"
PRINT #2, "#Drawing Welcome Screen                  [PASSED]"
PRINT #2, "!System Started                         ? [ERRORS]"
PRINT #2, ""
PRINT #2, ""
PRINT #2, "The following errors were found:"
PRINT #2, ""
PRINT #2, " Unable to delete ChetTemp Files. Probable Cause:"
PRINT #2, "     ChetTemp file missing or hidden or read-only."
PRINT #2, " Uncritical Error."
PRINT #2, ""
PRINT #2, " Unable to initalize ChetScript Engine. Probable Cause:"
PRINT #2, "     ChetScript has not been added to this version."
PRINT #2, " Uncritical Error, control panel will not function."
PRINT #2, ""
PRINT #2, " Error starting system. Probable Cause:"
PRINT #2, "     1 or more functions failed to initalize."
PRINT #2, " May be a critical error."
PRINT #2, ""
PRINT #2, " Error running final system startup. Probable Cause:"
PRINT #2, "     1 or more functions failed to initalize."
PRINT #2, " May be a critical error."
PRINT #2, ""
PRINT #2, ""
PRINT #2, "Overall system startup: SUCCESSFUL"
nogo3:
CLOSE #2

END SUB

SUB ScreenSaver

IF SaverEnabled = 1 THEN
' --- Weird Circles Screen Saver ---
    MouseXOld% = MouseX%
    MouseYOld% = MouseY%

IF ActiveSaver = 1 THEN
CLS
MouseHide
RANDOMIZE TIMER
ScrClr = 257
CLS
SCREEN 12
700
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF checkMMove = 1 THEN GOTO donecirclesaver
B = 300
c = 5
FOR a = 1 TO 400 STEP 2
CIRCLE (B, c), a, ScrClr
GOSUB cScrClr
PRINT
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF checkMMove = 1 THEN GOTO donecirclesaver
NEXT

B = 1
c = 200
FOR a = 1 TO 400 STEP 2
CIRCLE (B, c), a, ScrClr
GOSUB cScrClr
PRINT
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF checkMMove = 1 THEN GOTO donecirclesaver
NEXT

B = 100
c = 100
FOR a = 1 TO 500 STEP 4
CIRCLE (B, c), a, ScrClr
GOSUB cScrClr
PRINT
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF checkMMove = 1 THEN GOTO donecirclesaver
NEXT

B = 200
c = 200
FOR a = 1 TO 400 STEP 2
CIRCLE (B, c), a, ScrClr
GOSUB cScrClr
PRINT
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF checkMMove = 1 THEN GOTO donecirclesaver
NEXT

B = 200
c = 200
FOR a = 400 TO 10 STEP -3
CIRCLE (B, c), a, ScrClr
GOSUB cScrClr
PRINT
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF checkMMove = 1 THEN GOTO donecirclesaver
NEXT
GOTO 700
cScrClr:
ScrClr% = ScrClr% + 1
IF ScrClr > 270 THEN ScrClr = 257
IF ScrClr = 263 THEN LET ScrClr = 265
jump = INT(RND * 50) + 1
offset = INT(RND * 100) + 1
posorneg = INT(RND * 1)
IF jump = 5 THEN
        IF posorneg = 0 THEN B = B + (offset * 2)
        IF posorneg = 1 THEN B = B - (offset * 2)
END IF
RETURN
donecirclesaver:
rescreen "Desktop", 1: mouseShow
END IF

' --- Warp Star Screen Saver ---

IF ActiveSaver = 2 THEN
cxx1 = 0
cxx2 = 1
cxx3 = 3
CLS
MouseHide
CLS
    DIM Sine%(360), Cosine%(360)
    DIM StarAngle%(200), StarDistance%(200)
    DIM OldStarX%(200), OldStarY%(200)
    DIM StarTransX%(200), StarTransY%(200)
    DIM StarSpeed%(200)
    NumStars% = 200

    FOR N% = 0 TO 360
        Sine%(N%) = SIN(N% / 57.2958) * 20
        Cosine%(N%) = COS(N% / 57.2958) * 20
    NEXT N%

    FOR N% = 1 TO NumStars%
        StarAngle%(N%) = INT((360 - 1 + 1) * RND + 1)
        StarDistance%(N%) = INT((1000 - 1 + 1) * RND + 1)
        StarSpeed%(N%) = INT((100 - 1 + 1) * RND + 1)
    NEXT N%

    SCREEN 12
    WINDOW (-10000, -10000)-(10000, 10000)
   
    DO
       CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
       IF checkMMove = 1 THEN EXIT DO
       FOR k% = 1 TO 6
       FOR N% = 1 TO NumStars%
           StarDistance%(N%) = (StarDistance%(N%) + StarSpeed%(N%)) MOD 1000
           StarTransX%(N%) = (Cosine%(StarAngle%(N%))) - (Sine%(StarAngle%(N%))) * StarDistance%(N%)
           StarTransY%(N%) = (Sine%(StarAngle%(N%))) + (Cosine%(StarAngle%(N%))) * StarDistance%(N%)
       NEXT N%
       
       FOR N% = 1 TO NumStars%
          CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
          IF checkMMove = 1 THEN EXIT DO
          IF cxx1 > 1 THEN cxx1 = cxx1 + 1
          IF cxx1 = 4 THEN cxx1 = 1
          IF cxx2 > 1 THEN cxx2 = cxx2 + 1
          IF cxx2 = 4 THEN cxx2 = 1
          IF cxx3 > 1 THEN cxx3 = cxx3 + 1
          IF cxx3 = 4 THEN cxx3 = 1

           PSET (OldStarX%(N% - 1), OldStarY%(N% - 1)), k
           PSET (OldStarX%(N% - 1), OldStarY%(N% - 3)), k
           PSET (OldStarX%(N% - 1), OldStarY%(N% - 5)), k
           PSET (OldStarX%(N% - 1), OldStarY%(N% - 7)), 0
           PSET (OldStarX%(N%), OldStarY%(N%)), 0
           PSET (StarTransX%(N%), StarTransY%(N%)), StarDistance%(N%) \ 68 + 17
           OldStarX%(N%) = StarTransX%(N%)
           OldStarY%(N%) = StarTransY%(N%)
       NEXT N%
       Key$ = INKEY$
      
       NEXT k%
    LOOP UNTIL Key$ <> "" OR MID$(Key$, 2, 1) <> ""
WINDOW
rescreen "Desktop", 1
END IF

' ----- Spiral Screen Saver -----

IF ActiveSaver = 3 THEN
DEFSNG P
SCREEN 13
pixcol = 228
CLS
DIM pixr AS SINGLE
DIM pixcos AS SINGLE
DIM pixcircr AS SINGLE
pixcosinc = .1
PixRangeCurrLow = 215
PixRangeCurrHigh = 244
DO
IF pixcos > 1 THEN pixcosincflag = 1
IF pixcos < .02 THEN pixcosincflag = 0
IF pixcosincflag = 0 THEN pixcosinc = pixcosinc + .01
IF pixcosincflag = 1 THEN pixcosinc = pixcosinc - .01
pixcos = 0
pixr = 0
pixcircr = 1
IF pixcoldir = -1 THEN pixcol = pixcol + 2
IF pixcoldir = 0 OR pixcoldir = 1 THEN pixcol = pixcol - 2
pixcoldir = -1
PixRangeCurrLow = PixRangeCurrLow + 10
PixRangeCurrHigh = PixRangeCurrHigh + 10
DO UNTIL pixr > 180
  pixx = 160 + (COS(pixcos) * pixr * 1.3)
  pixy = 100 + (SIN(pixcos) * pixr)
  CIRCLE (pixx, pixy), pixcircr, pixcol
  pixcos = pixcos + pixcosinc
  pixr = pixr + .005
  pixcircr = pixcircr + .0005
  pixcol = pixcol + (1 * pixcoldir)
  IF pixcol < PixRangeCurrLow OR pixcol > PixRangeCurrHigh THEN pixcoldir = -pixcoldir
IF pixcos > (PI * 2) THEN pixcos = pixcos - (PI * 2)
CALL MouseStatus(lb%, rb%, MouseX%, MouseY%)
IF checkMMove = 1 THEN GOTO nospiral
LOOP
LOOP
nospiral:
SCREEN 12
rescreen "Desktop", 1
END IF

mouseShow

END IF


END SUB

DEFSNG A-O, Q-Z
SUB ShowCoord
' Shows the location of the mouse pointer
' I had these 4 lines in the loops for a long time, finally
' I realized it is easier (and faster for the program) to REM
' out just 1 line instead of 4    |-)
LOCATE 10, 10: PRINT "X = "; MouseX%
LOCATE 11, 10: PRINT "Y = "; MouseY%
LOCATE 12, 10: PRINT "Lb= "; lb%
LOCATE 13, 10: PRINT "Rb= "; rb%
END SUB

SUB ShutDown
' Displays a final screen
MouseHide
clr% = 3
clr2% = 2
e% = -3
CALL JFont("X", 9, 10, 2, 1.4)
CALL JFont("X", 9, 64, 2, 1.4)
CALL JFont("X", 9, 185, 2, 1.4)
CALL JFont("X", 9, 593, 2, 1.4)
CALL JFont("xxx", 15, 16, 4, 1.4)
CALL JFont("xxxxxx", 15, 74, 3, 1.4)
CALL JFont("xxxx", 15, 195, 3, 1.4)
CALL JFont("xxx", 15, 603, 3, 1.4)
CALL JFont("`", 2, 9, 15, 1)
CALL JFont("`", 2, 64, 15, 1)
CALL JFont("`", 2, 185, 15, 1)
CALL JFont("`", 2, 593, 15, 1)

hehe 1, 634, 26, 446, 0
DO
e% = e% + 4
IF e% >= 634 THEN EXIT DO
LINE (e%, 26)-(e%, 447), clr%
LINE (e% + 2, 26)-(e% + 2, 447), clr2%
LOOP
' dbox (left%, Right%, YLeft%, bot%, clr%, fill%, fillclr%, dbl)
dbox 120, 500, 120, 250, 15, 1, 0, 0
CALL JFont("ChetOS Has Shutdown", 24, 181, 150, 2.4)
CALL JFont("Have a nice day", 4, 215, 200, 2.2)
LINE (0, 447)-(635, 463), 0, BF
LINE (0, 447)-(635, 463), 7, B
LINE (634, 26)-(634, 477), 7
CALL JFont("Active: Closed: Press Enter To Leave                                      **:**", 15, 4, 450, 1.4)
COLOR 0
RESTORE
CLOSE
RESET
END
END SUB

SUB StartMouse
' Sets inital varibles for mouse. Detects mouse
  ax% = 3
  MouseDriver ax%, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  rb% = ((bx% AND 2) <> 0)
  MouseX% = cx%
  MouseY% = dx%
MS% = mouseInit%
IF NOT MS% THEN
LET AMOUSE$ = "NO":
END IF
LET AMOUSE$ = "YES"
MouseRange 0, 0, 636, 477
END SUB

DEFINT A-Z
SUB SystemTest (item%)
IF fastload = 1 THEN GOTO nocool
IF item = 1 THEN
        GET (167, 300)-(484, 450), back&
        dbox 167, 484, 300, 450, 4, 1, 0, 0
        FOR B = 1 TO 30
        FOR a = 300 TO 450 STEP 4
                c = INT(RND(1) * 15 + 1)
                LINE (168, a)-(483, a), c
        NEXT
        FOR a = 168 TO 483 STEP 4
                c = INT(RND(1) * 15 + 1)
                LINE (a, 300)-(a, 450), c
        NEXT
        NEXT
        PUT (167, 300), back&, PSET
END IF

IF item = 2 THEN
        GET (167, 300)-(484, 450), back&
        FOR F = 1 TO 3
        dbox 167, 484, 300, 450, 4, 1, 0, 0
        FOR B = 1 TO 5
        FOR a = 315 TO 435 STEP 16
        FOR d = 179 TO 472 STEP 16
                c = INT(RND(1) * 15 + 1)
                e = INT(RND(1) * 10 + 1)
                CIRCLE (d, a), e, c
                               
        NEXT d
        NEXT a
        NEXT B
        NEXT F
        PUT (167, 300), back&, PSET
END IF


IF item = 3 THEN
GET (1, 1)-(320, 230), back&
PUT (1, 1), back&, PRESET
PUT (1, 1), back&, PSET
GET (320, 1)-(639, 230), back&
PUT (320, 1), back&, PRESET
PUT (320, 1), back&, PSET
GET (1, 230)-(320, 465), back&
PUT (1, 230), back&, PRESET
PUT (1, 230), back&, PSET
GET (320, 230)-(639, 465), back&
PUT (320, 230), back&, PRESET
PUT (320, 230), back&, PSET
GET (160, 115)-(480, 345), back&
PUT (160, 115), back&, PRESET
PUT (160, 115), back&, PSET
END IF

IF item = 4 THEN
mouseShow
SLEEP 1
MouseHide
END IF

IF item = 5 THEN
        GET (167, 300)-(484, 450), back&
        FOR F = 1 TO 3
        dbox 167, 484, 300, 450, 4, 1, 0, 0
        FOR B = 1 TO 5
        FOR a = 300 TO 450 STEP 4
                c = INT(RND(1) * 15 + 1)
                LINE (168, a)-(483, a), c
        NEXT
        FOR a = 168 TO 483 STEP 4
                c = INT(RND(1) * 15 + 1)
                LINE (a, 300)-(a, 450), c
        NEXT
        NEXT
        FOR B = 1 TO 2
        FOR a = 315 TO 435 STEP 16
        FOR d = 179 TO 472 STEP 16
                c = INT(RND(1) * 15 + 1)
                e = INT(RND(1) * 10 + 1)
                CIRCLE (d, a), e, c
                              
        NEXT d
        NEXT a
        NEXT B
        NEXT F
        PUT (167, 300), back&, PSET
END IF
IF item = 6 THEN
        GET (167, 300)-(484, 450), back&
        dbox 167, 484, 300, 450, 4, 1, 0, 0
        LINE (167, 315)-(484, 315), 15
        LINE (167, 438)-(484, 438), 15
        CALL JFont("File", 4, 168, 302, 1)
        CALL JFont("Options", 4, 198, 302, 1)
        CALL JFont("Menu", 4, 245, 302, 1)
        CALL JFont("Help", 4, 458, 302, 1)
        CALL JFont("Active:*******", 15, 168, 440, 1)
        CALL JFont("**:**", 15, 448, 440, 1)
        LINE (170, 320)-(180, 330), 4, BF
        LINE (170, 340)-(180, 350), 2, BF
        LINE (170, 360)-(180, 370), 6, BF
        LINE (170, 380)-(180, 390), 1, BF
        SLEEP 1
        PUT (167, 300), back&, PSET

END IF

IF item = 7 THEN
        GET (167, 300)-(484, 450), back&
        dbox 167, 484, 300, 450, 4, 1, 0, 0
        dbox 168, 483, 316, 437, 2, 1, 1, 0
        LINE (167, 315)-(484, 315), 15
        LINE (167, 438)-(484, 438), 15
        CALL JFont("File", 4, 168, 302, 1)
        CALL JFont("Options", 4, 198, 302, 1)
        CALL JFont("Menu", 4, 245, 302, 1)
        CALL JFont("Help", 4, 458, 302, 1)
        CALL JFont("Active:*******", 15, 168, 440, 1)
        CALL JFont("**:**", 15, 448, 440, 1)
        LINE (170, 320)-(180, 330), 4, BF
        LINE (170, 340)-(180, 350), 2, BF
        LINE (170, 360)-(180, 370), 6, BF
        LINE (170, 380)-(180, 390), 1, BF
        SLEEP 2
        PUT (167, 300), back&, PSET
END IF
nocool:

END SUB

FUNCTION testStart
OPEN "chetos.dat" FOR INPUT AS #1
LINE INPUT #1, dosdir$
LINE INPUT #1, nick$
LINE INPUT #1, numrun$
LINE INPUT #1, reload$
CLOSE
IF reload$ = "load,1" THEN testStart = 0: GOTO doneTestStart
CLS
COLOR 15
OPEN "chetos.cfg" FOR INPUT AS #1
DO
IF proLine$(1) = "mode" THEN mode$ = proLine$(1)
IF proLine$(1) = "ver" THEN ver! = VAL(proLine$(1))
IF proLine$(1) = "redraw" THEN redra = VAL(proLine$(1))
IF proLine$(1) = "created" THEN created$ = proLine$(1)
IF proLine$(1) = "fastload" THEN fastload = VAL(proLine$(1))
 IF EOF(1) <> 0 THEN CLOSE #1: EXIT DO
LOOP
OPEN "desktop.cfg" FOR INPUT AS #26
DO
IF proLine$(26) = "deskclr1" THEN deskclr1% = VAL(proLine$(26))
IF proLine$(26) = "deskclr2" THEN deskclr2% = VAL(proLine$(26))
IF EOF(26) <> 0 THEN CLOSE #26: EXIT DO
LOOP
IF deskclr1% = 0 THEN deskclr1% = 1
IF deskclr2% = 0 THEN deskclr2% = 2
InitScreen
GetIcon
InitMouse
OPEN "fontdata.dat" FOR INPUT AS #3
FOR a = 1 TO 126
        FOR x = 1 TO 8
                FOR y = 1 TO 6
                        INPUT #3, B
                        charset(a, x, y) = B  'loads font data into 3-D array.
                NEXT y
        NEXT x
NEXT a
CLOSE #3
CALL JFont("Desktop", 15, 3, 1, 1.4)
GET (1, 1)-(57, 14), DeskTop%
CALL JFont("Ok", 7, 60, 1, 1.4)
GET (59, 1)-(83, 14), okimg%
CALL JFont("Cancel", 7, 85, 1, 1.4)
GET (85, 1)-(158, 14), cancelimg%
InitStats
testStart = 1
doneTestStart:
END FUNCTION

' Shows the time and date. (I got this idea from MacOS)
' This is the most optimized sub in the program, it needs to be because it is
' run in almost every menu and box.
SUB timedate (t%)

IF t% = 0 THEN
        timetime$ = TIME$
        IF LEN(TIME$) = 8 THEN dtime$ = LEFT$(TIME$, 5): ttime$ = RIGHT$(dtime$, 2): seconds$ = RIGHT$((RTRIM$(LTRIM$(TIME$))), 2): GOTO skip
        IF LEN(TIME$) = 7 THEN dtime$ = LEFT$(TIME$, 4): ttime$ = RIGHT$(dtime$, 2): seconds$ = RIGHT$((RTRIM$(LTRIM$(TIME$))), 2)
skip:
IF yy4% = 0 THEN
        MouseHide
        ottime% = VAL(ttime$) + 1
        yy4% = 1
        CALL hehe(557, 634, 466, 477, 0)
        CALL JFont(dtime$, 15, 597, 466, 1.4)
        mouseShow
END IF
IF VAL(ttime$) = ottime% THEN
                CALL hehe(557, 634, 466, 477, 0)
                CALL JFont(dtime$, 15, 597, 466, 1.4)
                ottime% = VAL(ttime$) + 1
END IF
END IF
IF t% = 1 THEN
        IF yy4% = 0 THEN
                MouseHide
                CALL hehe(557, 634, 466, 477, 0)
                CALL JFont(DATE$, 15, 557, 466, 1.4)
                mouseShow
                yy4% = 1
        END IF
END IF
 IF checkMMove = 1 THEN NTimer = VAL(seconds$) + SaverDelay
IF NTimer = VAL(seconds$) THEN ScreenSaver: NTimer = VAL(seconds$) + SaverDelay
MouseXOld% = MouseX%
MouseYOld% = MouseY%
END SUB

DEFSNG A-Z
FUNCTION vConvert% (c%, p%, ch$)
' Converts the "locate" statement's coords to pixel coords (vertically)
' C%=Chars
' P%=Pixels
' If ch$=c then converts from chars to pixels
' If ch$=p then converts from pixels to chars
IF ch$ = "c" THEN
vConvert% = INT(c% * 16)
END IF
IF ch$ = "p" THEN
vConvert% = INT(p% / 16)
END IF

END FUNCTION

SUB Win (left%, Right%, Top%, bot%, clr%, Title$)
' Left is the top area of the "box"; Right is the bottom area.
' YLeft is the left area; Bot is the right area.
' Clr% is the outer color
' Title$ is the title of the window
CALL dbox(left%, Right%, Top%, bot%, clr%, 1, 0, 1)
LINE (left%, Top% + 18)-(Right%, Top% + 18), clr%
CALL JFont(Title$, 15, left% + 4, Top% + 3, 1.8)
END SUB

SUB ZActive (status$)
' This tells you what you can do, or where your at.
CALL hehe(63, 300, 466, 477, 0)
IF status$ = "Desktop" THEN PUT (64, 466), DeskTop%
IF status$ <> "Desktop" THEN CALL JFont(status$, 15, 64, 466, 1.4)
END SUB

